SystemOrganization addCategory: #'Skeleton-Base'!
SystemOrganization addCategory: #'Skeleton-Base-Sheet'!
SystemOrganization addCategory: #'Skeleton-CSV'!

!Player methodsFor: '*skeleton-base' stamp: 'tak 3/31/2004 13:21'!
asCellText
	^ '=References at: #', self uniqueNameForReference! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/14/2011 19:37'!
clearColumn
	0 to: self getTotalRows - 1 do: [:i |
		self sheet removeAt: self getColumnIndex @ i
	]! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/14/2011 19:37'!
clearRow
	0 to: self getTotalColumns - 1 do: [:i |
		self sheet removeAt: i @ self getRowIndex
	]! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/14/2011 19:37'!
clearTable
	0 to: self getTotalColumns - 1 do: [:i |
		0 to: self getTotalRows - 1 do: [:j |
			self sheet removeAt: i @ j
		]
	]! !

!Player methodsFor: '*skeleton-base' stamp: 'Richo 10/14/2011 19:35'!
csvFileName
	^self sheetMorph valueOfProperty: #csvFileName ifAbsent: ['fileName.csv'].! !

!Player methodsFor: '*skeleton-base' stamp: 'Richo 10/14/2011 19:35'!
csvFileName: aString
	self sheetMorph setProperty: #csvFileName toValue: aString! !

!Player methodsFor: '*skeleton-base' stamp: 'Richo 10/14/2011 19:35'!
csvSeparator
	^ self sheetMorph valueOfProperty: #csvSeparator ifAbsent: [$,].! !

!Player methodsFor: '*skeleton-base' stamp: 'Richo 10/14/2011 19:35'!
csvSeparator: aCharacter
	self sheetMorph setProperty: #csvSeparator toValue: aCharacter! !

!Player methodsFor: '*skeleton-data i/o' stamp: 'Richo 10/18/2011 15:32'!
exportDataToFile
	[self saveCSVFile: self csvFileName separator: self csvSeparator]
		on: Error do: [:err| ^ self inform: err description]! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/14/2011 19:37'!
getColumnIndex
	^ self sheetMorph selection ifNil: [0] ifNotNil: [:rect | rect origin x]! !

!Player methodsFor: '*skeleton-data i/o' stamp: 'Richo 10/14/2011 19:36'!
getCsvFileName
	^ self csvFileName! !

!Player methodsFor: '*skeleton-data i/o' stamp: 'Richo 10/14/2011 19:36'!
getCsvSeparator
	^ self csvSeparator asString! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/14/2011 19:37'!
getCurrentCharacters
	^ (self sheet cellAt: self getColumnIndex @ self getRowIndex) contents! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/14/2011 19:37'!
getCurrentNumericValue
	| str |
	^ [(str := self getCurrentCharacters) asNumber]
			ifError: [:err :rcvr | str asInteger ifNil: [0]]! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/14/2011 19:37'!
getRowIndex
	^ self sheetMorph selection ifNil: [0] ifNotNil: [:rect | rect origin y]! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/14/2011 19:37'!
getTotalColumns
	^ self sheetMorph visibleArea corner x! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/14/2011 19:38'!
getTotalRows
	^ self sheetMorph visibleArea corner y! !

!Player methodsFor: '*skeleton-data i/o' stamp: 'Richo 10/14/2011 19:36'!
getWriteMode
	^ self writeMode! !

!Player methodsFor: '*skeleton-data i/o' stamp: 'Richo 10/14/2011 19:36'!
importDataFromFile
[[self openCSVFile: self csvFileName separator: self csvSeparator] 
	on: FileDoesNotExistException do: [:err | self inform: 'The file doesn''t exist.' translated]]
	on: Error do: [:err | self inform: 'An error occurred. Please check if the file''s format is CSV.' translated].! !

!Player methodsFor: '*skeleton-data i/o' stamp: 'Richo 10/24/2011 10:18'!
openCSVFile: filePath separator: separator
	FileStream 
		readOnlyFileNamed: filePath 
		do: [:file || values rows columns |
			values := CSVParser parse: file delimiter: separator.
			rows := values size.
			columns := values first size.
			self setTotalRows: rows + 1;
				setTotalColumns: columns + 1.
			1 to: rows do: [:r|
				1 to: columns do: [:c |
					((values at: r) at: c ifAbsent: nil)
						ifNotNil: [:aString || cell |
							cell := self sheet assuredCellAt: c @ r.
							(aString beginsWith: '=')
								ifTrue: [cell formula: aString]
								ifFalse: [cell contents: aString]
							]]]].! !

!Player methodsFor: '*skeleton-base' stamp: 'Richo 10/18/2011 15:38'!
rows
	^ (1 to: self getTotalRows - 1) collect: [:r |
		(1 to: self getTotalColumns - 1) collect: [:c || cell |
			cell := self sheet cellAt: c @ r.
			(cell hasFormula and: [self sheetMorph showFormula])
				ifTrue: [cell formula asString]
				ifFalse: [cell contents asString]]]! !

!Player methodsFor: '*skeleton-data i/o' stamp: 'Richo 10/14/2011 19:37'!
saveCSVFile: filePath separator: separator
	FileStream 
		perform: (self writeMode = #overwrite ifTrue: [#forceNewFileNamed:do:] ifFalse: [#fileNamed:do:])
		with: filePath
		with: [:file |
			file setToEnd.
			self rows do: [:row |
				row do: [:cell | file 
						nextPut: $";
						nextPutAll: (cell copyReplaceAll: '"' with: '""');
						nextPut: $"] 
					separatedBy: [file nextPut: separator].
				file cr]]! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/14/2011 19:38'!
setColumnIndex: aNumber
	self sheetMorph selectSelection: (aNumber \\ self getTotalColumns) @ self getRowIndex! !

!Player methodsFor: '*skeleton-data i/o' stamp: 'Richo 10/14/2011 19:37'!
setCsvFileName: aString
	self csvFileName: aString! !

!Player methodsFor: '*skeleton-data i/o' stamp: 'Richo 10/14/2011 19:37'!
setCsvSeparator: aString
	^ self csvSeparator: (aString at: 1 ifAbsent: $,)! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/14/2011 19:38'!
setCurrentCharacters: aString
	(self sheet assuredCellAt: self getColumnIndex @ self getRowIndex) contents: aString! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/14/2011 19:38'!
setCurrentNumericValue: aNumber
	self setCurrentCharacters: aNumber asString! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/14/2011 19:38'!
setRowIndex: aNumber
	self sheetMorph selectSelection: self getColumnIndex @ (aNumber \\ self getTotalRows)! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/18/2011 12:12'!
setTotalColumns: aNumber
	^ self sheetMorph area: (0@0 corner: (aNumber max: 2) @ self getTotalRows)! !

!Player methodsFor: '*skeleton-spreadsheet' stamp: 'Richo 10/18/2011 12:12'!
setTotalRows: aNumber
	^ self sheetMorph area: (0@0 corner: self getTotalColumns @ (aNumber max: 2))! !

!Player methodsFor: '*skeleton-data i/o' stamp: 'Richo 10/14/2011 19:37'!
setWriteMode: aSymbol
	(#(overwrite append) includes: aSymbol)
		ifTrue: [self writeMode: aSymbol]! !

!Player methodsFor: '*skeleton-base' stamp: 'Richo 10/14/2011 19:35'!
sheet
	^ self sheetMorph model! !

!Player methodsFor: '*skeleton-base' stamp: 'Richo 10/14/2011 19:35'!
sheetMorph
	^ self costume renderedMorph! !

!Player methodsFor: '*skeleton-base' stamp: 'Richo 10/14/2011 19:36'!
writeMode
	^self sheetMorph valueOfProperty: #writeMode ifAbsent: [#overwrite].! !

!Player methodsFor: '*skeleton-base' stamp: 'Richo 10/14/2011 19:36'!
writeMode: aSymbol
	self sheetMorph setProperty: #writeMode toValue: aSymbol! !

!PasteUpMorph methodsFor: '*skeleton-base-pentrail' stamp: 'tak 9/30/2003 01:45'!
createOrResizeTrailsForm
	"If necessary, create a new turtleTrailsForm or resize the existing one to fill my bounds. On return, turtleTrailsForm exists and is the correct size."

	| newForm |
	turtleTrailsForm ifNil:
		["create new TrailsForm if needed"
		turtleTrailsForm _ Form extent: self extent depth: 32.
		turtleTrailsForm fillColor: self color.
		turtlePen _ nil].

	turtleTrailsForm extent = self extent ifFalse:
		["resize TrailsForm if my size has changed"
		newForm _ Form extent: self extent depth: 32.
		newForm fillColor: self color.
		newForm copy: self bounds from: turtleTrailsForm
					to: 0@0 rule: Form paint.
		turtleTrailsForm _ newForm.
		turtlePen _ nil].

	"Recreate Pen for this form"
	turtlePen ifNil: [turtlePen _ Pen newOnForm: turtleTrailsForm.
					turtlePen combinationRule: Form blend].! !

!PhraseTileMorph methodsFor: '*skeleton-base-arrow' stamp: 'tak 10/1/2003 12:32'!
arrowTargets
	^ Array with: 'player' -> self actualObject! !

!Color methodsFor: '*skeleton-base' stamp: 'tak 3/31/2004 12:39'!
asCellText
	^ '=', self asString! !

!SequenceableCollection methodsFor: '*skeleton-base-sheet' stamp: 'tak 12/16/2003 21:11'!
split: delimitor do: aBlock
	| start end |
	start _ 1.
	[start <= self size] whileTrue: 
		[end _ self indexOf: delimitor startingAt: start ifAbsent: [self size + 1].
		end _ end - 1.
		aBlock value: (self copyFrom: start  to: end).
		start _ end + 2]

"
See SkSheetTest>>testSplitDo
'first	second		forth' delimited: Character tab do: [:aField | Transcript cr; show: aField]
'first
second

forth
' delimited: Character tab do: [:aField | Transcript cr; show: aField]
"! !

!ScriptEditorMorph methodsFor: '*skeleton-base-arrow' stamp: 'tak 10/1/2003 12:33'!
arrowTargets
	^ Array with: 'player' -> playerScripted! !

Parser subclass: #SkParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkParser class methodsFor: 'support' stamp: 'tak 1/21/2004 10:29'!
pointToA1Name: aPoint 
	"(self new pointToA1Name: 1@1) = 'A1'  
	(self new pointToA1Name: 10@10) = 'J10'  
	(self new pointToA1Name: 100@100) = 'CV100'"
	| base i dest remain xPos |
	base _ 26.
	dest _ aPoint x.
	i _ 1.
	xPos _ (String
				streamContents: [:aStream | [dest > 0]
						whileTrue: [remain _ dest \\ (i * base).
							dest _ dest - remain.
							aStream
								nextPut: (Character value: 64 + (remain / i)).
							i _ i * base]]) reverse.
	^ xPos , aPoint y printString! !

!SkParser methodsFor: 'error correction' stamp: 'tak 1/21/2004 09:22'!
A1Node: proposedVariable interval: spot 
	| receiver argument |
	receiver _ encoder
				encodeVariable: 'holder'
				sourceRange: spot
				ifUnknown: [encoder undeclared: proposedVariable].
	argument _ encoder
				encodeLiteral: (self cellPositionOf: proposedVariable).
	^ MessageNode new
		receiver: receiver
		selector: #at:
		arguments: (Array with: argument)
		precedence: 3
		from: encoder! !

!SkParser methodsFor: 'error correction' stamp: 'tak 1/21/2004 09:21'!
cellPositionOf: aString 
	"(self new cellPositionOf: 'A1') = (1@1)"
	"(self new cellPositionOf: 'B2') = (2@2)"
	"(self new cellPositionOf: 'CV100') = (100@100)"
	| col |
	col _ aString stemAndNumericSuffix first
				inject: 0
				into: [:subTotal :next | 
					subTotal _ subTotal * 26.
					subTotal _ subTotal + next asciiValue - $A asciiValue + 1].
	^ col @ aString stemAndNumericSuffix second asNumber! !

!SkParser methodsFor: 'error correction' stamp: 'tak 1/21/2004 09:23'!
correctVariable: proposedVariable interval: spot 
	| receiver argument |
	(self isA1Name: proposedVariable)
		ifTrue: [^ self A1Node: proposedVariable interval: spot].
	receiver _ encoder
				encodeVariable: 'holder'
				sourceRange: spot
				ifUnknown: [encoder undeclared: proposedVariable].
	argument _ encoder encodeLiteral: proposedVariable.
	^ MessageNode new
		receiver: receiver
		selector: #findName:
		arguments: (Array with: argument)
		precedence: 3
		from: encoder"^ encoder global: #Moge -> 1 name: #Hoge"! !

!SkParser methodsFor: 'testing' stamp: 'tak 1/21/2004 09:19'!
isA1Name: aString 
	" 
	(self new isA1Name: 'A1') = true. 
	(self new isA1Name: 'XYZ123') = true. 
	(self new isA1Name: '123') = false. 
	(self new isA1Name: 'ABC') = false. 
	(self new isA1Name: 'Abc') = false. 
	(self new isA1Name: 'abc') = false. 
	(self new isA1Name: 'Hello12') = false. 
	"
	| begin end number |
	begin _ aString indexOfAnyOf: ($A to: $Z) asCharacterSet startingAt: 0.
	begin isZero
		ifTrue: [^ false].
	end _ aString indexOfAnyOf: ($A to: $Z) asCharacterSet complement startingAt: begin.
	end isZero
		ifTrue: [^ false].
	number _ (aString allButFirst: end - 1).
	^ (number anySatisfy: [:c | c isDigit not]) not! !

!Morph methodsFor: '*skeleton-base-arrow' stamp: 'tak 10/1/2003 12:35'!
arrowTargets
	| player friends |
	player _ self player
				ifNil: [^ #()].
	friends _ OrderedCollection new.
	player class allInstVarNames
		withIndexDo: [:name :index | ((#(#dependents #costume #costume ) includes: name) not
					and: [(player instVarAt: index)
							isKindOf: Player])
				ifTrue: [friends add: name
							-> (player instVarAt: index)]].
	^ friends! !

!Morph methodsFor: '*skeleton-base-sheet' stamp: 'tak 12/27/2003 08:07'!
endHaloInteraction! !

!Morph methodsFor: '*skeleton-base-arrow' stamp: 'tak 10/1/2003 12:34'!
showPointArrow
	"ActiveWorld submorphsDo: [:m | m showPointArrow]"
	self arrowTargets
		do: [:each | self
				showPointArrowFrom: each value costume
				to: self
				label: each key]! !

!Morph methodsFor: '*skeleton-base-arrow' stamp: 'Richo 10/18/2011 12:10'!
showPointArrowFrom: morph1 to: morph2 label: aString 
	"Morph new showPointArrowFrom: (Morph new position: 0@0) to: (Morph  
	new position: 200@200) label: 'test'"
	| p1 p2 arrow label connector |
	p1 := morph1 center.
	p2 := morph2 center.
	arrow := PolygonMorph arrowPrototype.
	arrow
		borderColor: (TranslucentColor
				r: 1.0
				g: 0.3
				b: 0.0
				alpha: 0.6).
	arrow
		setVertices: (Array with: p1 with: p2).
	arrow dashedBorder: {30. 30. Color transparent. 0. -10};
		 startStepping.
	arrow openInWorld.
	arrow addAlarm: #delete after: 500! !

Morph subclass: #SkGridMorph
	instanceVariableNames: 'area converter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

SkGridMorph subclass: #SkBasicSheetMorph
	instanceVariableNames: 'history model selectionMorph dropZone showFormula'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkBasicSheetMorph commentStamp: 'tak 12/11/2003 19:10' prior: 0!
I am a presentation compornent for showing as 2-D grid.
The contents what I show is depended on a model.
I never access to a cell directly except through model because
a cell doesn't know where he locates. Basically, Position information is
only in model.

cellArea		Rectangle -- the area of cells for drawing. Actual size of table is cellArea extent.
model		SkSheet --
!

!SkBasicSheetMorph class methodsFor: 'viewer categories' stamp: 'Richo 10/14/2011 17:36'!
additionsToViewerCategories
^ #(
(#spreadsheet (
#(command clearTable 'Deletes the contents of all cells')
#(command clearRow 'Deletes the contents of the current row cells' )
#(command clearColumn 'Deletes the contents of the current columns cells' )
#(slot totalRows 'Lets you change the amount of rows in the spreadsheet' Number readWrite Player getTotalRows Player setTotalRows:  )
#(slot totalColumns 'Lets you change the amount of columns in the spreadsheet' Number readWrite Player getTotalColumns Player setTotalColumns:  )
#(slot rowIndex 'Sets the current row' Number readWrite Player getRowIndex Player setRowIndex:  )
#(slot columnIndex 'Sets the current column' Number readWrite Player getColumnIndex Player setColumnIndex:  )
#(slot currentCharacters 'Lets you read and modify the characters of the current cell' String readWrite Player getCurrentCharacters Player setCurrentCharacters:  )
#(slot currentNumericValue 'Lets you read and modify the numeric value of the current cell' Number readWrite Player getCurrentNumericValue Player setCurrentNumericValue:  )
))

(#'data i/o' (
#(slot writeMode 'Lets you choose a write mode (overwrite or append)' WriteMode readWrite Player getWriteMode Player setWriteMode:  )
#(slot csvSeparator 'Lets you choose a character to act as a separator between cells' String readWrite Player getCsvSeparator Player setCsvSeparator:  )
#(slot csvFileName 'Sets the name of the file to import/export data' String readWrite Player getCsvFileName Player setCsvFileName:  )
#(command importDataFromFile 'Reads the data from the file and loads it in the spreadsheet')
#(command exportDataToFile 'Writes the data from the spreadsheet into the file')
))

)! !

!SkBasicSheetMorph class methodsFor: 'class initialization' stamp: 'Richo 10/14/2011 19:50'!
initialize
	"
	self initialize.
	"
	Vocabulary addStandardVocabulary: (SymbolListType new vocabularyName: #WriteMode;
			 symbols: #(#overwrite #append)).! !

!SkBasicSheetMorph class methodsFor: 'instance creation' stamp: 'tak 12/25/2003 18:38'!
model: aSkObject 
	^ super new model: aSkObject! !

!SkBasicSheetMorph methodsFor: 'drag and drop' stamp: 'Richo 10/24/2011 11:03'!
acceptDroppingMorph: aMorph event: evt 
	| cellPos successed |
	cellPos _ self screenToCell: aMorph topLeft.
	(cellPos x < 1
			or: [cellPos y < 1])
		ifTrue: [self beep: 'scratch'.
			^ aMorph rejectDropMorphEvent: evt].
	successed _ false.
	successed _ (aMorph isKindOf: SkGridPartsMorph)
				ifTrue: [self acceptRuleMorph: aMorph event: evt]
				ifFalse: [aMorph class = PhraseTileMorph
						ifTrue: [self acceptPhraseTileMorph: aMorph event: evt]
						ifFalse: [aMorph class = TileMorph
								ifTrue: [self acceptTileMorph: aMorph event: evt]]].
	successed
		ifTrue: [self beep: 'clink']
		ifFalse: [self beep: 'scratch'.
			aMorph rejectDropMorphEvent: evt]! !

!SkBasicSheetMorph methodsFor: 'drag and drop' stamp: 'tak 1/24/2004 16:02'!
acceptPhraseTileMorph: aMorph event: evt 
	| setter getter |
	getter _ aMorph operatorTile operatorOrExpression.
	setter _ ('set'
				, (getter allButFirst: 3) , ':') asSymbol.
	self model
		modelAt: (self screenToCell: aMorph topLeft)
		for: aMorph actualObject
		getter: getter
		setter: setter.
	^ true! !

!SkBasicSheetMorph methodsFor: 'drag and drop' stamp: 'tak 1/24/2004 16:34'!
acceptRuleMorph: aMorph event: evt 
	| cellPos card |
	model parent adopt: aMorph model rule.
	cellPos _ (self screenToCell: aMorph topLeft)
				+ (aMorph cellOrigin - aMorph area topLeft).
	self model textAt: cellPos put: '=' , aMorph model codeString.
	card _ self
				cardMorphAt: cellPos
				ifAbsent: [^ false].
	card model rule = aMorph model rule
		ifFalse: ["maybe successed"
			^ false].
	aMorph halo
		ifNotNilDo: [:halo | halo setTarget: card].
	^ true! !

!SkBasicSheetMorph methodsFor: 'drag and drop' stamp: 'tak 1/24/2004 16:03'!
acceptTileMorph: aMorph event: evt 
	| object |
	object _ aMorph actualObject.
	self model
		at: (self screenToCell: aMorph topLeft)
		put: object.
	^ true! !

!SkBasicSheetMorph methodsFor: 'layout' stamp: 'tak 12/25/2003 02:03'!
areaChanged
	super areaChanged.
	self
		submorphsDo: [:m | (m isKindOf: SkGridMorph)
				ifTrue: [m areaChanged]]! !

!SkBasicSheetMorph methodsFor: 'accessing' stamp: 'tak 1/24/2004 15:54'!
cardMorphAt: aPoint ifAbsent: aBlock 
	^ self submorphs
		detect: [:m | m class = SkCardMorph
				and: [m cellOrigin = aPoint]]
		ifNone: aBlock! !

!SkBasicSheetMorph methodsFor: 'layout' stamp: 'tak 12/30/2003 20:01'!
cellExtentAt: aPoint 
	| cellExtent x y |
	^ (model notNil
			and: [(cellExtent _ model findName: self cellExtentName) class == SkSheet ])
		ifTrue: [x _ (cellExtent
						at: aPoint x @ 1
						ifAbsent: [SkGridMorph standardCellExtent]) x.
			y _ (cellExtent
						at: 1 @ aPoint y
						ifAbsent: [SkGridMorph standardCellExtent]) y.
			x @ y]
		ifFalse: [SkGridMorph standardCellExtent]! !

!SkBasicSheetMorph methodsFor: 'layout' stamp: 'tak 1/19/2004 00:35'!
cellExtentName
	^ 'CellExtent'! !

!SkBasicSheetMorph methodsFor: 'action' stamp: 'tak 12/19/2003 14:12'!
copySelection
	| text |
	text _ Text
				streamContents: [:aStream | self selection top
						to: self selection bottom - 1
						do: [:y | 
							(self selection left to: self selection right - 1)
								do: [:x | aStream
										nextPutAll: (model textAt: x @ y)]
								separatedBy: [aStream nextPut: Character tab].
							aStream nextPut: Character cr]].
	Clipboard clipboardText: text! !

!SkBasicSheetMorph methodsFor: 'action' stamp: 'tak 12/30/2003 17:25'!
cut
	self copySelection.
	self selection top
		to: self selection bottom - 1
		do: [:y | self selection left
				to: self selection right - 1
				do: [:x | model textAt: x @ y put: '']]! !

!SkBasicSheetMorph methodsFor: 'drawing' stamp: 'tak 1/22/2004 21:26'!
drawCell: aCanvas at: aPoint 
	(aPoint x isZero
			or: [aPoint y isZero])
		ifTrue: [^ self
				drawLabel: aCanvas
				string: (self labelAt: aPoint)
				at: aPoint].
	self flag: #TODO.
	self
		drawContents: ((showFormula notNil
					and: [showFormula])
				ifTrue: [model textAt: aPoint]
				ifFalse: [ showFormula _ false.model at: aPoint.])
		on: aCanvas
		at: aPoint! !

!SkBasicSheetMorph methodsFor: 'drawing' stamp: 'Richo 10/18/2011 12:37'!
drawOn: aCanvas 
	super drawOn: aCanvas.
	dropZone
		ifNotNil: [aCanvas
				fillRectangle: (self
						cellAreaToScreen: (dropZone intersect: area))
				fillStyle: (SkColorSet labelFor: model)
				borderStyle: self borderStyle].
	self drawDependMap: aCanvas.
	self drawBorder: aCanvas.
	self drawContents: aCanvas! !

!SkBasicSheetMorph methodsFor: 'accessing' stamp: 'tak 12/30/2003 17:00'!
editContents
self selection ifNil: [^''].
	^ model
		ifNil: ['']
		ifNotNil: [model textAt: self selection origin]! !

!SkBasicSheetMorph methodsFor: 'accessing' stamp: 'tak 12/30/2003 17:01'!
editContents: aText 
	"Accept text"
	self selection ifNil: [^self].
	model
		ifNotNil: [model textAt: self selection origin put: aText].
	selectionMorph deleteEditor! !

!SkBasicSheetMorph methodsFor: 'visual properties' stamp: 'tak 1/22/2004 21:36'!
fillStyle
	^ SkColorSet baseFor: model rule! !

!SkBasicSheetMorph methodsFor: 'navigation' stamp: 'Richo 10/24/2011 11:03'!
goto: aSkObject 
	| grid |
	self beep: 'click'.
	grid _ aSkObject grid.
	self replace: grid.
	grid history: self.
	^ grid! !

!SkBasicSheetMorph methodsFor: 'event handling' stamp: 'tak 12/16/2003 17:15'!
handlesKeyboard: evt 
	^ true! !

!SkBasicSheetMorph methodsFor: 'event handling' stamp: 'Richo 10/18/2011 10:06'!
handlesMouseDown: evt 
	^ true! !

!SkBasicSheetMorph methodsFor: 'event handling' stamp: 'tak 12/21/2003 21:25'!
handlesMouseOverDragging: evt

	^ true
! !

!SkBasicSheetMorph methodsFor: 'event handling' stamp: 'tak 12/21/2003 21:25'!
handlesMouseOver: evt
	^ true
! !

!SkBasicSheetMorph methodsFor: 'accessing' stamp: 'Richo 10/14/2011 17:31'!
height: aNumber
	^ self setExtentFromHalo: self width @ aNumber! !

!SkBasicSheetMorph methodsFor: 'navigation' stamp: 'tak 1/23/2004 01:33'!
history: aSkSheetMorph 
	history
		ifNil: [history _ aSkSheetMorph]! !

!SkBasicSheetMorph methodsFor: 'initialization' stamp: 'Richo 10/18/2011 12:25'!
initialize
	super initialize.
	selectionMorph _ SkGridSelectionMorph new holder: self.
	self
		area: (1 @ 1 extent: 4 @ 4).
	self
		borderStyle: (RaisedBorder color: Color black width: 1).
	self
		fillStyle: (SolidFillStyle
				color: (Color
						r: 1.0
						g: 0.935
						b: 0.839)).
	self cornerStyle: #rounded.
	self selection: nil.
	showFormula _ false! !

!SkBasicSheetMorph methodsFor: 'parts bin' stamp: 'tak 1/11/2004 15:45'!
initializeToStandAlone
	super initializeToStandAlone.
	self model: SkSheet new attachProject.
	self
		area: (0 @ 0 extent: 3 @ 3)! !

!SkBasicSheetMorph methodsFor: 'stepping and presenter' stamp: 'tak 12/29/2003 18:16'!
isModelStepping
	^ model isStepping! !

!SkBasicSheetMorph methodsFor: 'classification' stamp: 'tak 1/24/2004 09:47'!
isMorphicModel
	^true! !

!SkBasicSheetMorph methodsFor: 'event handling' stamp: 'tak 12/16/2003 17:16'!
keyStroke: evt 
	selectionMorph keyStroke: evt! !

!SkBasicSheetMorph methodsFor: 'accessing' stamp: 'tak 12/10/2003 19:44'!
model
	^ model! !

!SkBasicSheetMorph methodsFor: 'accessing' stamp: 'tak 12/29/2003 20:36'!
model: anObject 
	model
		ifNotNil: [model removeDependent: self].
	anObject
		ifNotNil: [anObject addDependent: self].
	model _ anObject.
	self update: #all.
! !

!SkBasicSheetMorph methodsFor: 'event handling' stamp: 'tak 1/16/2004 11:09'!
mouseDown: event 
	self
		selectSelection: (self screenToCell: event position).
	event yellowButtonPressed
		ifTrue: [^ selectionMorph invokeMenu: event].
	"For easy doublecilck to selection"
	event hand waitForClicksOrDrag: selectionMorph event: event.
	event hand mouseFocus: selectionMorph! !

!SkBasicSheetMorph methodsFor: 'event handling' stamp: 'tak 12/21/2003 21:29'!
mouseEnterDragging: evt
	"Test button state elsewhere if at all"
	^ self mouseEnter: evt! !

!SkBasicSheetMorph methodsFor: 'event handling' stamp: 'tak 12/21/2003 21:46'!
mouseEnter: evt 
	| hand tile |
	hand _ evt hand.
	hand submorphs size = 1
		ifFalse: [^ self].
	tile _ hand firstSubmorph renderedMorph.
	(self wantsDroppedMorph: tile event: evt)
		ifFalse: [^ self].
	self
		startStepping: #trackDropZones
		at: Time millisecondClockValue
		arguments: nil
		stepTime: 20! !

!SkBasicSheetMorph methodsFor: 'event handling' stamp: 'tak 12/21/2003 21:31'!
mouseLeaveDragging: evt 
	^ self mouseLeave: evt! !

!SkBasicSheetMorph methodsFor: 'event handling' stamp: 'tak 12/21/2003 21:39'!
mouseLeave: evt 
	dropZone _ nil.
	self stopSteppingSelector: #trackDropZones! !

!SkBasicSheetMorph methodsFor: 'event handling' stamp: 'tak 12/30/2003 22:06'!
mouseUpTick: evt onItem: aMorph 
	aMorph isTicking
		ifTrue: [model stopStepping.
			aMorph isTicking: false]
		ifFalse: [model startStepping.
			aMorph isTicking: true]! !

!SkBasicSheetMorph methodsFor: 'action' stamp: 'tak 1/24/2004 17:50'!
openLibrary
	(SkObject root at: 'Library') grid openInHand! !

!SkBasicSheetMorph methodsFor: 'action' stamp: 'tak 12/19/2003 14:15'!
paste
	| pos selection isJustACell |
	selection _ self selection.
	isJustACell _ selection extent = (1 @ 1).
	pos _ selection origin.
	Clipboard clipboardText
		split: Character cr
		do: [:line | 
			line
				split: Character tab
				do: [:field | 
					(isJustACell
							or: [selection containsPoint: pos])
						ifTrue: [model textAt: pos put: field].
					pos _ pos + (1 @ 0)].
			pos _ selection left @ (pos y + 1)]! !

!SkBasicSheetMorph methodsFor: 'navigation' stamp: 'Richo 10/24/2011 11:03'!
previousPage
	self beep: 'click'.
	^ history
		ifNotNil: [self replace: history]! !

!SkBasicSheetMorph methodsFor: 'private' stamp: 'Richo 10/24/2011 11:05'!
privateRemoveMorph: aMorph 
	aMorph class = SkCardMorph
		ifTrue: [self beep: 'scratch'.
			self model textAt: aMorph cellOrigin put: ''].
	super privateRemoveMorph: aMorph! !

!SkBasicSheetMorph methodsFor: 'navigation' stamp: 'Richo 10/18/2011 11:28'!
replace: aSkSheetMorph 
	aSkSheetMorph area: self area.
	aSkSheetMorph position: self position.
	self owner replaceSubmorph: self by: aSkSheetMorph.
	^ aSkSheetMorph! !

!SkBasicSheetMorph methodsFor: 'accessing' stamp: 'tak 12/11/2003 22:20'!
selection
	^ selectionMorph area! !

!SkBasicSheetMorph methodsFor: 'accessing' stamp: 'tak 1/7/2004 21:36'!
selectionMorph
	^ selectionMorph! !

!SkBasicSheetMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2011 10:56'!
selection: aRectangle 
	(submorphs indexOf: selectionMorph) = 1
		ifFalse: [self addMorphFront: selectionMorph].
	selectionMorph area: aRectangle! !

!SkBasicSheetMorph methodsFor: 'action' stamp: 'tak 1/7/2004 21:33'!
selectSelection: aPoint 
	"Select at event position"
	aPoint
		ifNil: [^ self].
	self
		selection: (aPoint extent: 1 @ 1).
	self changed! !

!SkBasicSheetMorph methodsFor: 'layout' stamp: 'tak 1/8/2004 15:23'!
setCellExtentFromHalo: newExtent 
	| eachExtent cellExtent |
	model
		ifNil: [^ self].
	cellExtent _ model
				at: self cellExtentName
				ifAbsent: [model
						at: self cellExtentName
						put: (SkSheet new parent: model)].
	eachExtent _ newExtent // self selection extent max: 10 @ 10.
	self selection left
		to: self selection right - 1
		do: [:x | cellExtent at: x @ 1 put: eachExtent].
	self selection top
		to: self selection bottom - 1
		do: [:y | cellExtent at: 1 @ y put: eachExtent].
	self areaChanged.
	self changed! !

!SkBasicSheetMorph methodsFor: 'layout' stamp: 'tak 1/18/2004 16:24'!
setExtentFromHalo: newExtent 
	| card cardMorph direction size |
	super setExtentFromHalo: newExtent.
	direction := nil.
	area height = 1 
		ifTrue: 
			[direction := #right.
			size := area width - 1]
		ifFalse: 
			[area width = 1 
				ifTrue: 
					[direction := #down.
					size := area height - 1]].
	direction ifNotNil: 
			[card := model new.
			card direction: direction.
			card size: size.
			cardMorph := SkCardMorph model: card.
			cardMorph position: self position.
			self owner addMorph: cardMorph.
			self halo ifNotNilDo: [:helo | helo setTarget: cardMorph].
			self delete]! !

!SkBasicSheetMorph methodsFor: 'accessing' stamp: 'tak 1/3/2004 16:21'!
showFormula
	^ showFormula! !

!SkBasicSheetMorph methodsFor: 'action' stamp: 'tak 1/21/2004 10:26'!
spawn
	model inspectAt: self selection topLeft! !

!SkBasicSheetMorph methodsFor: 'action' stamp: 'tak 1/21/2004 10:27'!
spawn: anObject
	self spawn! !

!SkBasicSheetMorph methodsFor: 'stepping and presenter' stamp: 'tak 12/23/2003 19:45'!
startStepping
	model
		ifNotNil: [model startStepping].
	super startStepping.
! !

!SkBasicSheetMorph methodsFor: 'stepping and presenter' stamp: 'tak 1/2/2004 18:01'!
step
	self changed! !

!SkBasicSheetMorph methodsFor: 'accessing' stamp: 'tak 1/3/2004 16:22'!
toggleFormula
	showFormula _ showFormula not! !

!SkBasicSheetMorph methodsFor: 'event handling' stamp: 'tak 1/11/2004 23:05'!
trackDropZones
	| hand target |
	hand _ self primaryHand.
	((self hasOwner: hand) not
			and: [hand submorphCount > 0])
		ifTrue: [target _ hand submorphs first.
			dropZone _ (self screenToCell: target topLeft)
						extent: ((target respondsTo: #area)
								ifTrue: [target area extent]
								ifFalse: [1 @ 1]).
			(dropZone topLeft x < 1
					or: [dropZone topLeft y < 1])
				ifTrue: [dropZone _ nil].
			self changed]
		ifFalse: [dropZone _ nil.
			self stopSteppingSelector: #trackDropZones]! !

!SkBasicSheetMorph methodsFor: 'accessing' stamp: 'tak 12/22/2003 18:38'!
tryToRenameTo: aName 
	^ model
		ifNotNilDo: [:m | m name: aName]! !

!SkBasicSheetMorph methodsFor: 'updating' stamp: 'tak 1/12/2004 22:33'!
updateCardList
	| cardList morph |
	cardList _ model cardList: self visibleArea.
	self
		removeAllMorphsIn: (self submorphs
				select: [:m | m class == SkCardMorph]).
	cardList
		do: [:cardInfo | 
			morph _ SkCardMorph model: cardInfo value.
			morph holder: self.
			self addMorph: morph.
			morph cellOrigin: cardInfo key].
	selectionMorph hide! !

!SkBasicSheetMorph methodsFor: 'updating' stamp: 'tak 1/2/2004 18:00'!
update: anObject 
	anObject = #cardList
		ifTrue: [self updateCardList].
	anObject = #all
		ifTrue: [self updateCardList].
	self changed! !

!SkBasicSheetMorph methodsFor: 'navigation' stamp: 'Richo 10/24/2011 11:05'!
upPage
	self beep: 'click'.
	^ self goto: model up! !

!SkBasicSheetMorph methodsFor: 'copying' stamp: 'tak 1/28/2004 23:18'!
veryDeepInner: deepCopier 
	"history is not copied"
	model _ model veryDeepCopyWith: deepCopier.
	selectionMorph _ (selectionMorph veryDeepCopyWith: deepCopier) holder: self.
	dropZone _ dropZone veryDeepCopyWith: deepCopier.
	showFormula _ showFormula veryDeepCopyWith: deepCopier.
	super veryDeepInner: deepCopier! !

!SkBasicSheetMorph methodsFor: 'drag and drop' stamp: 'tak 1/7/2004 16:21'!
wantsDroppedMorph: aMorph event: anEvent 
	^ aMorph class = PhraseTileMorph
		or: [aMorph class = TileMorph
				or: [aMorph isKindOf: SkGridPartsMorph]]! !

!SkBasicSheetMorph methodsFor: 'accessing' stamp: 'Richo 10/14/2011 17:31'!
width: aNumber
	^ self setExtentFromHalo: aNumber @ self height! !

!SkGridMorph class methodsFor: 'constant' stamp: 'tak 12/24/2003 21:50'!
standardCellExtent
	^ 80 @ 20! !

!SkGridMorph class methodsFor: 'constant' stamp: 'tak 3/29/2004 10:35'!
titleStyle
	#(#NewYork #Accujen )
		do: [:fontName | (TextStyle named: fontName)
				ifNotNilDo: [:style | ^ style fontOfPointSize: 24]].
	Error signal: 'Font not found'! !

!SkGridMorph methodsFor: 'accessing' stamp: 'tak 12/21/2003 14:07'!
area
	^ area
! !

!SkGridMorph methodsFor: 'layout' stamp: 'tak 12/27/2003 18:20'!
areaChanged
	| newBounds |
	self visibleArea
		ifNil: [^ self hide]
		ifNotNil: [converter _ SkCellScreenConverter grid: self border: 1.
			self show.
			newBounds _ self cellAreaToScreen: self visibleArea.
			self position: newBounds topLeft.
			self extent: newBounds extent]! !

!SkGridMorph methodsFor: 'accessing' stamp: 'tak 1/7/2004 16:24'!
area: aRectangle 
	area = aRectangle
		ifTrue: [^ self].
	area _ aRectangle.
	self areaChanged.
	self changed! !

!SkGridMorph methodsFor: 'visual properties' stamp: 'tak 12/25/2003 21:15'!
borderStyle
	^ self model
		ifNil: [super borderStyle]
		ifNotNil: [SkColorSet borderStyleFor: self model rule]! !

!SkGridMorph methodsFor: 'layout' stamp: 'tak 12/27/2003 18:08'!
cellAreaToScreen: aRectangle
 	^ converter cellAreaToScreen: aRectangle topLeft: self topLeft + self expandSize! !

!SkGridMorph methodsFor: 'layout' stamp: 'tak 1/7/2004 15:58'!
cellExtentAt: aPoint 
	^self class standardCellExtent! !

!SkGridMorph methodsFor: 'accessing' stamp: 'tak 12/26/2003 18:44'!
cellOrigin
	^ area origin
! !

!SkGridMorph methodsFor: 'layout' stamp: 'tak 12/27/2003 18:04'!
cellToScreenRect: aPoint 
	^ converter cellToScreenRect: aPoint topLeft: self topLeft + self expandSize! !

!SkGridMorph methodsFor: 'drawing' stamp: 'tak 12/26/2003 15:09'!
drawBorder: aCanvas 
	| y offset x borderColor borderWidth |
	offset _ self borderWidth // 2.
	borderColor _ self borderColor.
	borderWidth _ self borderWidth.
	self visibleArea top
		to: self visibleArea bottom - 2
		do: [:row | 
			y _ (self cellToScreenRect: self visibleArea right @ row) bottom + offset.
			aCanvas
				fillRectangle: (self left + borderWidth @ y corner: self right - borderWidth @ y + 1)
				color: borderColor].
	self visibleArea left
		to: self visibleArea right - 2
		do: [:col | 
			x _ (self cellToScreenRect: col @ self visibleArea top) right + offset.
			aCanvas
				fillRectangle: (x @ (self top + borderWidth) corner: x + 1 @ (self bottom - borderWidth))
				color: borderColor]! !

!SkGridMorph methodsFor: 'drawing' stamp: 'tak 1/7/2004 18:38'!
drawCell: aCanvas at: aPoint 
! !

!SkGridMorph methodsFor: 'drawing' stamp: 'tak 1/24/2004 14:17'!
drawContents: aCanvas 
	| block |
	block _ [self model
				ifNil: [^ self].
			self visibleArea top
				to: self visibleArea bottom - 1
				do: [:row | self visibleArea left
						to: self visibleArea right - 1
						do: [:col | self drawCell: aCanvas at: col @ row]]].
	self isDebug
		ifTrue: [[block value]
				ifError: [:err :rcvr | rcvr]]
		ifFalse: [block value]! !

!SkGridMorph methodsFor: 'drawing' stamp: 'tak 1/20/2004 09:03'!
drawContents: anObject on: aCanvas at: aPoint 
	"To debug, try 
	self drawCell: World canvas at: 2@6  
	"
	| aRectangle string morph |
	(anObject isSkObject)
		ifTrue: [^ self].
	(anObject isKindOf: Player)
		ifTrue: [^ self
				drawPlayer: anObject
				on: aCanvas
				at: aPoint].
	anObject = ''
		ifTrue: [^ self].
	aRectangle _ self localCellToScreenRect: aPoint.
	string _ anObject isString
				ifTrue: [anObject]
				ifFalse: [anObject isNumber
						ifTrue: [anObject asString]].
	string
		ifNil: [morph _ anObject isText
						ifTrue: [TextMorph new contents: anObject]
						ifFalse: [(anObject isKindOf: Player)
								ifTrue: [anObject costume]
								ifFalse: [anObject asMorph]].
			aCanvas
				translateTo: aRectangle topLeft - morph bounds origin
				clippingTo: (aRectangle topLeft corner: self bottomRight)
				during: [:c | morph drawOn: c]]
		ifNotNil: [aCanvas
				drawString: string
				in: (aRectangle expandBy: -2)
				font: TextStyle defaultFont
				color: Color black]! !

!SkGridMorph methodsFor: 'drawing' stamp: 'tak 1/11/2004 14:06'!
drawDependMap: aCanvas 
	| subjectColor dependArray observer subjects observerColor |
	subjectColor _ SkColorSet selectedFor: self model rule.
	observerColor _ subjectColor adjustBrightness: -0.06.
	dependArray _ self model rule collectDependents.
	"draw subjects"
	aCanvas
		clipBy: self bounds
		during: [:canvas | 
			(dependArray
				inject: Set new
				into: [:set :next | set addAll: next allButFirst;
						 yourself])
				do: [:each | canvas
						fillOval: ((self localCellToScreenRect: each) center - (7 @ 7) extent: 14 @ 14)
						fillStyle: subjectColor].
			"draw objerver and line"
			dependArray
				do: [:each | 
					observer _ each first.
					subjects _ each allButFirst.
					canvas
						fillOval: ((self localCellToScreenRect: observer) center - (4 @ 4) extent: 8 @ 8)
						fillStyle: observerColor.
					subjects
						do: [:end | canvas
								line: (self localCellToScreenRect: observer) center
								to: (self localCellToScreenRect: end) center
								width: 1
								color: observerColor]]]! !

!SkGridMorph methodsFor: 'drawing' stamp: 'tak 1/22/2004 10:55'!
drawGrabAreaOn: aCanvas 
	| rect borderColor |
	borderColor _ self borderColor.
	rect _ self grabArea.
	rect left
		to: rect right
		by: 2
		do: [:x | aCanvas
				frameRectangle: (x @ rect top corner: x + 1 @ rect bottom)
				color: borderColor]! !

!SkGridMorph methodsFor: 'drawing' stamp: 'tak 1/22/2004 10:35'!
drawLabel: aCanvas string: aString at: aPoint 
	| aRectangle |
	aRectangle _ self localCellToScreenRect: aPoint.
	aCanvas
		clipBy: self bounds
		during: [:canvas | 
			canvas
				fillRectangle: aRectangle
				color: (SkColorSet
						labelFor: (self model
								ifNotNil: [self model rule])).
			canvas
				drawString: aString asString
				in: ((aRectangle expandBy: -2)
						withLeft: aRectangle left + 6)
				font: ScriptingSystem fontForTiles
				color: Color black]! !

!SkGridMorph methodsFor: 'drawing' stamp: 'tak 1/17/2004 11:04'!
drawPlayer: aPlayer on: aCanvas at: aPoint 
	"To debug, try  
	self drawCell: World canvas at: 2@6  
	"
	| aRectangle morph form scaleX scaleY scale |
	morph _ aPlayer costume.
	aRectangle _ self localCellToScreenRect: aPoint.
	form _ morph imageForm.
	scaleY _ aRectangle height / form height.
	scaleX _ aRectangle width / form width.
	scale _ (scaleX min: scaleY)
				min: 1.
	form _ form
				magnify: form boundingBox
				by: scale @ scale
				smoothing: 2.
	aCanvas translucentImage: form at: (aRectangle topLeft + (aRectangle extent - form extent / 2)) asIntegerPoint! !

!SkGridMorph methodsFor: 'accessing' stamp: 'tak 12/24/2003 10:12'!
expandSize
	^ 0! !

!SkGridMorph methodsFor: 'accessing' stamp: 'tak 1/19/2004 08:43'!
externalName
	^ self model
		ifNotNilDo: [:m | "name can be nil"
			m ruleName asString]! !

!SkGridMorph methodsFor: 'visual properties' stamp: 'tak 12/25/2003 20:10'!
fillStyle: aFillStyle 
	super fillStyle: aFillStyle.
	self model
		ifNotNil: [SkColorSet for: self model rule color: aFillStyle asColor].
	self changed! !

!SkGridMorph methodsFor: 'layout' stamp: 'tak 12/25/2003 01:09'!
globalToLocal: aPoint 
	^ aPoint! !

!SkGridMorph methodsFor: 'accessing' stamp: 'tak 1/24/2004 16:30'!
grabArea
	^ (self topLeft corner: self right @ (self top + 16))
		insetBy: 3! !

!SkGridMorph methodsFor: 'debug' stamp: 'tak 1/24/2004 14:15'!
isDebug
	^ true! !

!SkGridMorph methodsFor: 'drawing' stamp: 'tak 1/7/2004 18:35'!
labelAt: aPoint 
	aPoint x = aPoint y
		ifTrue: [^ ''].
	aPoint x = 0
		ifTrue: [^ aPoint y asString].
	^ ($A asInteger + aPoint x - 1) asCharacter asString! !

!SkGridMorph methodsFor: 'layout' stamp: 'tak 12/25/2003 01:11'!
localCellToScreenRect: aPoint 
	^ self cellToScreenRect: aPoint! !

!SkGridMorph methodsFor: 'accessing' stamp: 'tak 1/7/2004 17:44'!
model
	^ self subclassResponsibility! !

!SkGridMorph methodsFor: 'layout' stamp: 'tak 12/27/2003 18:10'!
screenToCell: aPoint 
	^ converter screenToCell: aPoint topLeft: self topLeft + self expandSize! !

!SkGridMorph methodsFor: 'layout' stamp: 'tak 12/25/2003 16:22'!
setExtentFromHalo: newExtent 
	"Answer new cell size"
	| newSize |
	newSize _ (self screenToCell: self topLeft + newExtent)
				- self area origin.
	newSize _ newSize max: 1 @ 1.
	self area extent ~~ newSize
		ifTrue: [self
				area: (self area origin extent: newSize)].
	^ newSize! !

!SkGridMorph methodsFor: 'accessing' stamp: 'tak 12/26/2003 18:50'!
visibleArea
	^ self area! !

SkGridMorph subclass: #SkGridPartsMorph
	instanceVariableNames: 'holder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

SkGridPartsMorph subclass: #SkCardMorph
	instanceVariableNames: 'model origin size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkCardMorph commentStamp: 'tak 12/26/2003 19:45' prior: 0!
I am a Card bar of a rule.

area		always NIL
model		SkRule (maybe SkCard)
origin		Point	a position of label
size			SmallInteger -- It is used when model has no size (it is ugly implementation...)

The morphs area is determined based on area's origin, size, and model's direction.!

!SkCardMorph class methodsFor: 'instance creation' stamp: 'tak 12/25/2003 13:44'!
model: aSkObject 
	^ super new model: aSkObject! !

!SkCardMorph class methodsFor: 'instance creation' stamp: 'tak 12/25/2003 13:45'!
new
	self error: 'SkCardMorph must only be created with model: aSkObject'! !

!SkCardMorph class methodsFor: 'instance creation' stamp: 'tak 12/25/2003 13:45'!
newFrom: aSkSheetMorph 
	| cardMorph |
	cardMorph _ self model: aSkSheetMorph model.
	cardMorph
		area: (0 @ 1 extent: aSkSheetMorph area width @ 1).
	cardMorph position: aSkSheetMorph position.
	^ cardMorph! !

!SkCardMorph methodsFor: 'rotate scale and flex' stamp: 'tak 12/25/2003 12:31'!
addFlexShellIfNecessary
	"When scaling or rotating from a halo, I can do this without a flex shell"

	^ self
! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 12/26/2003 18:38'!
area
	^ model direction = #right
		ifTrue: [origin extent: self size + 1 @ 1]
		ifFalse: [model direction = #down
				ifTrue: [origin extent: 1 @ (self size + 1)]
				ifFalse: [model direction = #left
						ifTrue: [origin - (self size @ 0) corner: origin + 1]
						ifFalse: [origin - (0 @ self size) corner: origin + 1]]]! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 1/7/2004 16:18'!
area: aRectangle 
	"area corner is determined by size and direction"
	self
		cellOrigin: ((#(#right #down ) includes: model direction)
				ifTrue: [aRectangle origin]
				ifFalse: [model direction = #left
						ifTrue: [aRectangle origin + (self size @ 0)]
						ifFalse: [aRectangle origin + (0 @ self size)]]).
	self isHorizonal
		ifTrue: [self size: aRectangle width - 1]
		ifFalse: [self size: aRectangle height - 1].
	self changed! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 12/26/2003 19:35'!
cellOrigin
	"The cell point which has label"
	^ origin! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 12/26/2003 19:18'!
cellOrigin: aPoint 
	"The cell point which has label"
	origin _ aPoint.
	self areaChanged.! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 12/25/2003 15:50'!
direction
	^ model direction! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 12/27/2003 19:59'!
direction: aSymbol 
	self
		keepCellOriginDo: [model direction: aSymbol]! !

!SkCardMorph methodsFor: 'event handling' stamp: 'Richo 10/18/2011 12:26'!
doubleClick: evt 
	| sheet |
	(holder notNil
			and: [owner = holder])
		ifTrue: [^ holder goto: model].
	self owner = World
		ifTrue: [self delete].
	sheet _ SkBasicSheetMorph allInstances
				detect: [:each | each world = World
						and: [each model = model]]
				ifNone: [model grid].
	sheet position: self position;
		 openInWorld! !

!SkCardMorph methodsFor: 'drawing' stamp: 'tak 1/19/2004 08:42'!
drawCell: aCanvas at: aPoint 
	| modelPoint |
	modelPoint _ self globalToLocal: aPoint.
	modelPoint = (0 @ 1)
		ifTrue: [^ self
				drawLabel: aCanvas
				string: model ruleName
				at: modelPoint].
	self drawContents: (model at: modelPoint) on: aCanvas at: modelPoint.
! !

!SkCardMorph methodsFor: 'drawing' stamp: 'tak 1/22/2004 10:56'!
drawOn: aCanvas 
	super drawOn: aCanvas.
	self drawGrabAreaOn: aCanvas.
	self drawContents: aCanvas.
	self drawBorder: aCanvas! !

!SkCardMorph methodsFor: 'event handling' stamp: 'tak 1/24/2004 17:51'!
endHaloInteraction
	self isOnHolder
		ifFalse: [^ self].
	holder model textAt: self cellOrigin put: '=' , model codeString.
	self halo
		ifNotNilDo: [:halo | 
			halo
				setTarget: (holder
						cardMorphAt: self cellOrigin
						ifAbsent: []).
			self delete]! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 12/27/2003 22:21'!
expandSize
	^ -2! !

!SkCardMorph methodsFor: 'visual properties' stamp: 'tak 12/25/2003 02:05'!
fillStyle
	^ SkColorSet baseFor: model rule! !

!SkCardMorph methodsFor: 'layout' stamp: 'tak 12/25/2003 11:31'!
globalToLocal: aPoint 
	"Transformation a position of cell"
	| normalized |
	normalized _ aPoint - self cellOrigin.
	model direction = #left
		ifTrue: [^ normalized * -1 + (0 @ 1)].
	model direction = #down
		ifTrue: [^ normalized transposed + (0 @ 1)].
	model direction = #up
		ifTrue: [^ normalized transposed * -1 + (0 @ 1)].
	^ normalized + (0 @ 1)! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 1/22/2004 11:34'!
grabArea
	| width inset base |
	width _ 16.
	inset _ 3.
	base _ self cellToScreenRect: self cellOrigin.
	^ model direction = #right
		ifTrue: [(base topLeft corner: base left + width @ base bottom)
				insetBy: inset]
		ifFalse: [model direction = #down
				ifTrue: [(base topLeft corner: base right @ (base top + width))
						insetBy: inset]
				ifFalse: [model direction = #left
						ifTrue: [(base right - width @ base top corner: base bottomRight)
								insetBy: inset]
						ifFalse: [(base left @ (base bottom - width) corner: base bottomRight)
								insetBy: inset]]]! !

!SkCardMorph methodsFor: 'event handling' stamp: 'tak 12/26/2003 13:21'!
handlesMouseDown: evt 
	^ (self screenToCell: evt position)
		= self cellOrigin! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 12/29/2003 11:25'!
holderArea
	^ 1@1 corner: holder area bottomRight! !

!SkCardMorph methodsFor: 'initialization' stamp: 'tak 12/27/2003 15:25'!
initialize
	super initialize.
	origin _ 0 @ 0.
	self
		borderStyle: (RaisedBorder color: Color black width: 1).
	self
		fillStyle: (SolidFillStyle
				color: (Color
						r: 1.0
						g: 0.935
						b: 0.839)).
	self cornerStyle: #rounded! !

!SkCardMorph methodsFor: 'testing' stamp: 'tak 1/7/2004 16:16'!
isHorizonal
	^ #(#right #left ) includes: model direction! !

!SkCardMorph methodsFor: 'classification' stamp: 'tak 1/24/2004 09:45'!
isMorphicModel
	^true! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 12/27/2003 19:58'!
keepCellOriginDo: aBlock 
	| oldOriginByScreen delta |
	oldOriginByScreen _ (self cellToScreenRect: self cellOrigin) topLeft.
	aBlock value.
	self areaChanged.
	delta _ oldOriginByScreen - (self cellToScreenRect: self cellOrigin) topLeft.
	self topLeft: self topLeft + delta.
	self areaChanged! !

!SkCardMorph methodsFor: 'layout' stamp: 'tak 12/25/2003 01:30'!
localCellToScreenRect: aPoint 
	^ self
		cellToScreenRect: (self localToGlobal: aPoint)! !

!SkCardMorph methodsFor: 'layout' stamp: 'tak 12/25/2003 11:26'!
localToGlobal: aPoint 
	| normalized |
	normalized _ aPoint + (0 @ -1).
	model direction = #left
		ifTrue: [^ normalized * -1 + self cellOrigin].
	model direction = #down
		ifTrue: [^ normalized transposed + self cellOrigin].
	model direction = #up
		ifTrue: [^ normalized transposed * -1 + self cellOrigin].
	^ normalized + self cellOrigin! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 12/21/2003 21:52'!
model
	^ model! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 1/24/2004 10:45'!
model: aSkRule 
	model _ aSkRule.
	self areaChanged! !

!SkCardMorph methodsFor: 'event handling' stamp: 'tak 1/25/2004 16:49'!
mouseDown: evt 
	"For easy doublecilck to selection"
	evt hand waitForClicksOrDrag: self event: evt.
	evt yellowButtonPressed
		ifTrue: [^ model invokeCardMenu: evt]
		ifFalse: [(self grabArea containsPoint: evt position)
				ifTrue: [evt hand grabMorph: self]]! !

!SkCardMorph methodsFor: 'rotate scale and flex' stamp: 'tak 12/26/2003 00:15'!
referencePosition
	^ (self cellToScreenRect: self cellOrigin) center! !

!SkCardMorph methodsFor: 'layout' stamp: 'Richo 10/18/2011 12:26'!
replaceToSheet: newCellExtent 
	"Create new spreadsheet for the model. And I will be deleted"
	| sheetMorph |
	(newCellExtent y > 1
			and: [newCellExtent x > 1])
		ifTrue: [sheetMorph _ SkBasicSheetMorph new model: model.
			sheetMorph
				area: (0 @ 0 extent: newCellExtent).
			sheetMorph position: self position.
			self owner addMorph: sheetMorph.
			self halo
				ifNotNilDo: [:helo | helo setTarget: sheetMorph].
			^ self delete]! !

!SkCardMorph methodsFor: 'rotate scale and flex' stamp: 'tak 1/7/2004 18:09'!
rotationDegrees: degrees 
	| d newDirection |
	d _ degrees \\ 360.
	newDirection _ #right.
	(d < 45
			or: [315 <= d])
		ifTrue: [newDirection _ #right]
		ifFalse: [d < 135
				ifTrue: [newDirection _ #down]
				ifFalse: [d < 225
						ifTrue: [newDirection _ #left]
						ifFalse: [d < 315
								ifTrue: [newDirection _ #up]]]].
	self forwardDirection: degrees.
	self direction ~~ newDirection
		ifTrue: ["Transcript show: ActiveHand target printString."
			self direction: newDirection.
			self halo
				ifNil: [self isOnHolder
						ifTrue: [holder model textAt: self cellOrigin put: '=' , model codeString]]].
	self changed! !

!SkCardMorph methodsFor: 'layout' stamp: 'tak 1/11/2004 17:10'!
setExtentFromHalo: newExtent 
	| newCellExtent nSize |
	newCellExtent _ (self screenToCell: ActiveHand position - 10)
				- origin.
	(newCellExtent y > 1
			and: [newCellExtent x > 1])
		ifTrue: [^ self replaceToSheet: newCellExtent].
	nSize _ (newCellExtent x abs max: newCellExtent y abs)
				max: 0.
	newCellExtent y > (0 - newCellExtent x)
		ifTrue: [newCellExtent y < newCellExtent x
				ifTrue: [self direction: #right]
				ifFalse: [self direction: #down]]
		ifFalse: [newCellExtent y < newCellExtent x
				ifTrue: [self direction: #up]
				ifFalse: [self direction: #left]].
	self size: nSize! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 12/25/2003 14:55'!
size
	^ model size
		ifNil: [size
				ifNil: [size _ 0]]! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 1/18/2004 16:19'!
size: aNumber 
	(aNumber > 0
			and: [model isInstance not])
		ifTrue: [self
				model: model new].
	self
		keepCellOriginDo: [model size
				ifNil: ["Maybe it doesn't need"
					nil.
					size _ aNumber]
				ifNotNil: [model size: aNumber]]! !

!SkCardMorph methodsFor: 'accessing' stamp: 'tak 1/19/2004 19:41'!
veryDeepInner: deepCopier 
	"rule is not copied"
	model _ model siblingWith: deepCopier.
	origin _ origin veryDeepCopyWith: deepCopier.
	size _ size veryDeepCopyWith: deepCopier.
	super veryDeepInner: deepCopier! !

!SkGridPartsMorph methodsFor: 'layout' stamp: 'tak 12/25/2003 20:54'!
cellAreaToScreen: aRectangle 
	^ (self isOnHolder
		ifTrue: [holder cellAreaToScreen: aRectangle]
		ifFalse: [super cellAreaToScreen: aRectangle])
		expandBy: self expandSize! !

!SkGridPartsMorph methodsFor: 'layout' stamp: 'tak 12/28/2003 14:49'!
cellToScreenRect: aRectangle 
	^ self isOnHolder
		ifTrue: [holder cellToScreenRect: aRectangle]
		ifFalse: [super cellToScreenRect: aRectangle]! !

!SkGridPartsMorph methodsFor: 'accessing' stamp: 'tak 1/28/2004 22:51'!
holder
	"it's only for test"
	^ holder.! !

!SkGridPartsMorph methodsFor: 'accessing' stamp: 'tak 12/29/2003 11:24'!
holderArea
	^ holder area! !

!SkGridPartsMorph methodsFor: 'accessing' stamp: 'tak 12/21/2003 21:12'!
holder: anObject
	holder _ anObject! !

!SkGridPartsMorph methodsFor: 'testing' stamp: 'tak 12/25/2003 20:54'!
isOnHolder
	^ holder notNil
		and: [owner = holder]! !

!SkGridPartsMorph methodsFor: 'copying' stamp: 'tak 1/28/2004 22:25'!
veryDeepInner: deepCopier 
	"holder is not copied"
! !

!SkGridPartsMorph methodsFor: 'accessing' stamp: 'tak 12/30/2003 16:48'!
visibleArea
	"Answer nil if no intersect"
	| visibleArea |
	self area
		ifNil: [^ nil].
	^ self isOnHolder
		ifTrue: [visibleArea _ self area intersect: self holderArea.
			visibleArea hasPositiveExtent
				ifTrue: [visibleArea]]
		ifFalse: [self area]! !

SkGridPartsMorph subclass: #SkGridSelectionMorph
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkGridSelectionMorph methodsFor: 'accessing' stamp: 'tak 1/21/2004 10:29'!
area: aRectangle 
	editor
		ifNil: [super area: aRectangle]
		ifNotNil: [(editor text isEmpty not
					and: [editor text first = $=
							and: [editor hasUnacceptedEdits]])
				ifTrue: [editor
						correctSelectionWithString: (SkParser pointToA1Name: aRectangle origin)]
				ifFalse: [editor accept.
					editor _ nil.
					super area: aRectangle]]! !

!SkGridSelectionMorph methodsFor: 'visual properties' stamp: 'tak 1/8/2004 23:48'!
borderStyle
	^ SkColorSet
		selectedBorderStyleFor: (holder
				ifNotNil: [holder model rule])! !

!SkGridSelectionMorph methodsFor: 'accessing' stamp: 'tak 12/12/2003 15:09'!
deleteEditor
	editor delete.
	editor _ nil! !

!SkGridSelectionMorph methodsFor: 'event handling' stamp: 'tak 1/12/2004 22:05'!
doubleClick: evt 
	(self bounds containsPoint: ActiveHand position)
		ifTrue: [self installEditor]! !

!SkGridSelectionMorph methodsFor: 'drawing' stamp: 'tak 12/21/2003 19:06'!
drawOn: aCanvas
	| clip |
	clip _ aCanvas copyClipRect: self bounds.
	super drawOn: aCanvas.
	editor
		ifNil: [holder drawBorder: clip.
			holder drawContents: clip]! !

!SkGridSelectionMorph methodsFor: 'accessing' stamp: 'tak 1/7/2004 21:37'!
editor
	^ editor! !

!SkGridSelectionMorph methodsFor: 'accessing' stamp: 'tak 1/22/2004 12:54'!
expandSize
	^ 2! !

!SkGridSelectionMorph methodsFor: 'accessing' stamp: 'tak 1/21/2004 10:29'!
externalName
	^ SkParser pointToA1Name: area topLeft! !

!SkGridSelectionMorph methodsFor: 'visual properties' stamp: 'tak 1/8/2004 23:48'!
fillStyle
	^ SkColorSet
		selectedFor: (holder
				ifNotNil: [holder model rule])! !

!SkGridSelectionMorph methodsFor: 'event handling' stamp: 'tak 12/16/2003 17:02'!
handlesKeyboard: evt 
	^ true! !

!SkGridSelectionMorph methodsFor: 'event handling' stamp: 'tak 12/16/2003 17:14'!
handlesMouseDown: evt 
	^ true! !

!SkGridSelectionMorph methodsFor: 'initialization' stamp: 'tak 1/22/2004 12:49'!
initialize
	super initialize.
	area _ 1 @ 1 extent: 4 @ 4.
	self
		borderStyle: (RaisedBorder color: Color black width: 1).
	self
		fillStyle: (SolidFillStyle
				color: (Color
						r: 1.0
						g: 0.935
						b: 0.839)).
"	self cornerStyle: #rounded"! !

!SkGridSelectionMorph methodsFor: 'event handling' stamp: 'tak 12/30/2003 17:00'!
installEditor
	self area ifNil: [^self].
	editor
		ifNil: [editor _ PluggableTextMorph
						on: holder
						text: #editContents
						accept: #editContents:].
	editor setProperty: #alwaysAccept toValue: true.
	editor acceptOnCR: true.
	editor hideScrollBarIndefinitely.
	editor borderWidth: 0.
	editor
		bounds: (holder cellToScreenRect: self area origin).
	editor selectAll.
	self addMorphFront: editor.
	ActiveHand newKeyboardFocus: editor.
	editor
		on: #mouseLeave
		send: holder
		to: #acceptCell! !

!SkGridSelectionMorph methodsFor: 'menu' stamp: 'tak 4/10/2004 23:02'!
invokeMenu: evt 
	| menu |
	menu _ MenuMorph new defaultTarget: holder.
	(holder model cellAt: self area topLeft) label
		ifNotNilDo: [:label | menu addTitle: label].
	menu
		add: (holder showFormula
				ifTrue: ['<on>']
				ifFalse: ['<off>'])
				, 'formula' translated
		target: holder
		selector: #toggleFormula.
	(holder model cellAt: self area topLeft) player
		ifNotNilDo: [:player | 
			menu
				add: 'reveal this object'
				target: player
				selector: #revealPlayerIn:
				argument: ActiveWorld.
			player costume
				showPointArrowFrom: player costume
				to: self
				label: ' '].
	menu addList: {{'library' translated. #openLibrary}.
				 #-.
				{'copy (c)' translated. #copySelection}.
				{'cut (x)' translated. #cut}.
				{'paste (v)' translated. #paste}.
				{'spawn (o)' translated. #spawn}}.
	menu popUpEvent: evt in: self world! !

!SkGridSelectionMorph methodsFor: 'event handling' stamp: 'tak 1/21/2004 10:27'!
keyStroke: evt 
	evt keyValue = $c asciiValue
		ifTrue: [^ holder copySelection].
	evt keyValue = $o asciiValue
		ifTrue: [^ holder spawn].
	evt keyValue = $v asciiValue
		ifTrue: [^ holder paste].
	evt keyValue = $x asciiValue
		ifTrue: [^ holder cut].
	self installEditor.
	editor ifNotNil: [editor keyStroke: evt].! !

!SkGridSelectionMorph methodsFor: 'accessing' stamp: 'tak 12/24/2003 10:00'!
model
	^ holder
		ifNotNil: [holder model]! !

!SkGridSelectionMorph methodsFor: 'event handling' stamp: 'tak 12/16/2003 22:31'!
mouseDown: evt 
	evt yellowButtonPressed
		ifTrue: [^ self invokeMenu: evt].
	owner
		ifNotNil: [owner mouseDown: evt]! !

!SkGridSelectionMorph methodsFor: 'event handling' stamp: 'tak 12/21/2003 16:54'!
mouseMove: evt 
	| newArea |
	newArea _ self area encompass: (holder screenToCell: evt position)
					+ 1.
	area _ newArea.
	self areaChanged! !

!SkGridSelectionMorph methodsFor: 'layout' stamp: 'tak 12/21/2003 19:43'!
screenToCell: aPoint 
	^ holder
		ifNil: [super screenToCell: aPoint]
		ifNotNil: [holder screenToCell: aPoint]! !

!SkGridSelectionMorph methodsFor: 'layout' stamp: 'tak 12/28/2003 10:55'!
setExtentFromHalo: newExtent 
	self isOnHolder
		ifTrue: [holder setCellExtentFromHalo: newExtent]! !

Morph subclass: #SkSheetMorph
	instanceVariableNames: 'sheet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkSheetMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/18/2011 13:04'!
additionsToViewerCategories
	^(Smalltalk at: #SkBasicSheetMorph ifAbsent: [^ #()])
		additionsToViewerCategories! !

!SkSheetMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/18/2011 12:33'!
descriptionForPartsBin
	^ self partName:	'Spreadsheet' translated
		categories:		{'Skeleton' translated}
		documentation:	'A spreadsheet' translated! !

!SkSheetMorph methodsFor: 'initialization' stamp: 'Richo 10/18/2011 12:29'!
addPageControls
	| panel prev up title |

	panel := AlignmentMorph newRow 
				color: Color transparent;
				cellInset: 3;
				hResizing: #shrinkWrap;
				vResizing: #shrinkWrap.
	panel addMorphBack: self tickMorph.
	prev := SketchMorph withForm: self prevButtonForm.
	prev
		on: #mouseDown
		send: #previousPage
		to: sheet.
	prev position: 32 @ 3.
	prev setBalloonText: 'View the previous sheet.' translated.
	panel addMorphBack: prev.
	up := SketchMorph withForm: self upButtonForm.
	up
		on: #mouseDown
		send: #upPage
		to: sheet.
	up position: 44 @ 4.
	up setBalloonText: 'View the definision or the parent rule.' translated.
	panel addMorphBack: up.
	title := UpdatingStringMorph new useStringFormat
		target: self;
		putSelector: #setNameTo:;
		getSelector: #externalName.
	panel addMorphBack: title.
	self addMorph: panel! !

!SkSheetMorph methodsFor: 'initialization' stamp: 'Richo 10/18/2011 11:44'!
addSheet: aSheet
	self addMorph: (sheet := aSheet).
	self renameTo: sheet externalName! !

!SkSheetMorph methodsFor: 'sheet delegation' stamp: 'Richo 10/18/2011 11:53'!
area: aRectangle 
	^ sheet area: aRectangle 
	! !

!SkSheetMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2011 16:26'!
color: aColor
	super color: aColor.
	sheet ifNotNil: [sheet fillStyle: aColor.
		self title color: aColor makeForegroundColor]! !

!SkSheetMorph methodsFor: 'dnu' stamp: 'Richo 10/18/2011 12:23'!
doesNotUnderstand: aMessage
	"Quick hack to automagically generate missing methods"
	self flag: #Richo.
	(sheet respondsTo: aMessage selector)
		ifTrue: [ | str |
			str := aMessage createStubMethod allButLast: 24.
			self class compile: str, '^ sheet ', str classified: #'autogenerated'.
			^aMessage sentTo: self.
			]
		ifFalse: [^super doesNotUnderstand: aMessage]! !

!SkSheetMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2011 12:28'!
extent: newExtent
	
	sheet setExtentFromHalo: (newExtent max: (165@77)) - 
								(self layoutInset + self cellInset + (0 @ self pageControls height))! !

!SkSheetMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2011 15:58'!
fillStyle: aFillStyle
	self color: aFillStyle! !

!SkSheetMorph methodsFor: 'initialization' stamp: 'Richo 10/18/2011 12:26'!
initialize
	super initialize.
	self layoutPolicy:	TableLayout new;
		cellPositioning: #leftCenter;
		cornerStyle: #rounded;
		color: (Color r: 0.645 g: 0.645 b: 1.0);
		borderWidth: 1;
		borderColor: (Color r: 0.516 g: 0.516 b: 1.0);
		listDirection: #topToBottom;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	self addSheet: SkBasicSheetMorph newStandAlone;
		addPageControls! !

!SkSheetMorph methodsFor: 'sheet delegation' stamp: 'Richo 10/18/2011 11:53'!
model
	^ sheet model! !

!SkSheetMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2011 11:42'!
pageControls
	^ self submorphs detect: [:each | each ~~ sheet]! !

!SkSheetMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2011 11:27'!
prevButtonForm
	^(Form
	extent: 9@16
	depth: 16
	fromArray: #( 0 0 0 0 0 0 0 0 0 831258624 0 0 0 12684 831258624 0 0 0 831279775 831258624 0 0 12684 1386173087 831258624 0 0 831279775 1386173087 831258624 0 12684 1386173087 1386173087 831258624 0 831279775 1386173087 1386173087 831258624 12684 1386173087 1386173087 1386173087 831258624 0 831279775 1386173087 1386173087 831258624 0 12684 1386173087 1386173087 831258624 0 0 831279775 1386173087 831258624 0 0 12684 1386173087 831258624 0 0 0 831279775 831258624 0 0 0 12684 831258624 0 0 0 0 831258624)
	offset: 522@183)! !

!SkSheetMorph methodsFor: 'submorphs-add/remove' stamp: 'Richo 10/18/2011 12:18'!
replaceSubmorph: oldMorph by: newMorph
	"Update page controls if the sheet gets replaced."
	^ oldMorph == sheet
		ifTrue: [self submorphsDo: [:each | each delete];
					addSheet: newMorph;
					addPageControls]
		ifFalse: [super replaceSubmorph: oldMorph by: newMorph]! !

!SkSheetMorph methodsFor: 'sheet delegation' stamp: 'Richo 10/18/2011 11:51'!
selection
	^ sheet selection
	! !

!SkSheetMorph methodsFor: 'sheet delegation' stamp: 'Richo 10/18/2011 11:53'!
selectSelection: aPoint 
	^ sheet selectSelection: aPoint 
	! !

!SkSheetMorph methodsFor: 'renaming' stamp: 'Richo 10/18/2011 12:14'!
setNameTo: aName
	sheet tryToRenameTo: aName.
	super setNameTo: aName! !

!SkSheetMorph methodsFor: 'autogenerated' stamp: 'Richo 10/18/2011 15:35'!
showFormula
	^ sheet showFormula
	! !

!SkSheetMorph methodsFor: 'stepping' stamp: 'Richo 10/18/2011 11:55'!
step
	sheet step! !

!SkSheetMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2011 11:24'!
tickMorph
	| tick |
	tick _ SkPluggableTickMorph new.
	tick on: sheet isTickingSel: #isModelStepping.
	tick
		on: #mouseUp
		send: #mouseUpTick:onItem:
		to: sheet.
	tick stepTime: 500.
	tick startStepping.
	tick setBalloonText: 'Press to toggle ticking state.' translated.
	^ tick! !

!SkSheetMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2011 15:55'!
title
	^ self pageControls findA: UpdatingStringMorph! !

!SkSheetMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2011 11:14'!
upButtonForm
	^ self prevButtonForm copy rotateBy: 90! !

!SkSheetMorph methodsFor: 'sheet delegation' stamp: 'Richo 10/18/2011 11:53'!
visibleArea
	^ sheet visibleArea
	! !

TickIndicatorMorph subclass: #SkPluggableTickMorph
	instanceVariableNames: 'model isTickingSel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkPluggableTickMorph methodsFor: 'accessing' stamp: 'tak 12/29/2003 18:05'!
isTicking
	^model perform: isTickingSel.
! !

!SkPluggableTickMorph methodsFor: 'accessing' stamp: 'tak 12/29/2003 18:15'!
on: anObject isTickingSel: tickSel
	model _ anObject.
	isTickingSel _ tickSel.
! !

!SkPluggableTickMorph methodsFor: 'accessing' stamp: 'tak 12/30/2003 22:02'!
runningColor
	^ Color
		r: 0.767
		g: 0.767
		b: 1.0! !

!SkPluggableTickMorph methodsFor: 'stepping and presenter' stamp: 'tak 12/30/2003 22:06'!
stepAt: nowTick 
	| delta |
	self isTicking
		ifTrue: [(lastTick isNil
					or: [nowTick < lastTick])
				ifTrue: [lastTick _ nowTick].
			delta _ nowTick - lastTick // stepTime.
			delta > 0
				ifTrue: [self color: self runningColor.
					index _ index + delta.
					lastTick _ nowTick.
					self changed]]
		ifFalse: [self color: self stoppedColor]! !

!SkPluggableTickMorph methodsFor: 'accessing' stamp: 'tak 12/30/2003 22:05'!
stoppedColor
	^ Color
		r: 1.0
		g: 0.774
		b: 0.774! !

Compiler subclass: #SkCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkCompiler class methodsFor: 'accessing' stamp: 'tak 1/21/2004 08:58'!
parserClass
	^ SkParser! !

ContextVariablesInspector subclass: #SkCellInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkCellInspector class methodsFor: 'initialize-release' stamp: 'tak 1/21/2004 10:04'!
holder: holder key: key 
	^ self new holder: holder key: key! !

!SkCellInspector methodsFor: 'accessing' stamp: 'tak 1/21/2004 10:06'!
contents
	^ self holder textAt: self key! !

!SkCellInspector methodsFor: 'accessing' stamp: 'tak 1/21/2004 10:07'!
contents: textOrString 
	^ self holder textAt: self key put: textOrString! !

!SkCellInspector methodsFor: 'accessing' stamp: 'tak 1/21/2004 10:18'!
holder
	^ object
		ifNotNil: [object tempAt: 1]! !

!SkCellInspector methodsFor: 'accessing' stamp: 'tak 1/21/2004 10:17'!
holder: holder key: key 
	| cell context |
	self holder
		ifNotNil: [self holder removeDependent: self].
	holder addDependent: self.
	cell _ holder cellAt: key.
	context _ MethodContext
				sender: holder
				receiver: cell
				method: SkNullCell >> #resolveContextOn:at:
				arguments: {holder. key}.
	self inspect: context! !

!SkCellInspector methodsFor: 'accessing' stamp: 'tak 1/21/2004 10:05'!
key
	^ object tempAt: 2! !

!SkCellInspector methodsFor: 'update' stamp: 'tak 1/21/2004 10:19'!
update: aSymbol
	self changed: #contents! !

Object subclass: #CSVParser
	instanceVariableNames: 'stream delimiter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-CSV'!

!CSVParser class methodsFor: 'instance creation' stamp: 'Richo 10/24/2011 01:07'!
on: stream delimiter: aCharacter
	^ self basicNew initializeWith: stream delimiter: aCharacter! !

!CSVParser class methodsFor: 'parsing' stamp: 'Richo 10/22/2011 19:07'!
parseString: aString
	^ self parse: aString readStream ! !

!CSVParser class methodsFor: 'parsing' stamp: 'Richo 10/24/2011 01:08'!
parseString: aString delimiter: aCharacter
	^ self parse: aString readStream delimiter: aCharacter! !

!CSVParser class methodsFor: 'parsing' stamp: 'Richo 10/24/2011 01:07'!
parse: aStream
	^ self parse: aStream delimiter: $,! !

!CSVParser class methodsFor: 'parsing' stamp: 'Richo 10/24/2011 01:07'!
parse: aStream delimiter: aCharacter
	^ (self on: aStream delimiter: aCharacter) parse! !

!CSVParser methodsFor: 'initialization' stamp: 'Richo 10/24/2011 01:08'!
initializeWith: aStream delimiter: aCharacter
	stream := aStream.
	delimiter := aCharacter.
	self initialize! !

!CSVParser methodsFor: 'parsing' stamp: 'Richo 10/24/2011 00:48'!
nextCell
	^ stream peek = $"
		ifTrue: [self nextEnclosedCell]
		ifFalse: [self nextNormalCell]! !

!CSVParser methodsFor: 'parsing' stamp: 'Richo 10/24/2011 10:13'!
nextEnclosedCell
	^ String streamContents: [:cell |
		stream skip: 1.
		[stream atEnd]
			whileFalse: [| next |
				next := stream next.
				next = $" 
					ifTrue: [
						stream peek ~= $"
							ifTrue: [^ cell contents]
							ifFalse: [stream skip: 1]].
				cell nextPut: next]]! !

!CSVParser methodsFor: 'parsing' stamp: 'Richo 10/24/2011 09:53'!
nextNormalCell
	^ String streamContents: [:cell |
		[stream atEnd]
			whileFalse: [| next |
				next := stream next.
				(next = delimiter
				or: [Character cr = next 
				or: [Character lf = next]])
					ifTrue: [stream skip: -1.
						^ cell contents].
				cell nextPut: next]]! !

!CSVParser methodsFor: 'parsing' stamp: 'Richo 10/24/2011 01:09'!
nextRow
	^ Array streamContents: [:cells |
		[stream atEnd or: [String crlf includes: stream peek]]
			whileFalse: [cells nextPut: self nextCell.
				stream peek = delimiter ifTrue: [stream skip: 1]]]! !

!CSVParser methodsFor: 'parsing' stamp: 'Richo 10/24/2011 01:22'!
parse
	^ Array streamContents: [:rows |
		[stream atEnd]
			whileFalse: [rows nextPut: self nextRow.
				[String crlf includes: stream peek] whileTrue: [stream skip: 1]]]! !

!Object methodsFor: '*skeleton-base' stamp: 'tak 3/31/2004 12:38'!
asCellText
	^ self asString! !

!Object methodsFor: '*skeleton-base' stamp: 'tak 1/18/2004 15:27'!
isSkObject
	^ false! !

!Object methodsFor: '*skeleton-base' stamp: 'tak 3/15/2004 12:49'!
rule: sub do: aBlock 
	^ SkRule new
		observer: self
		subjects: sub
		rule: aBlock! !

Object subclass: #SkCellScreenConverter
	instanceVariableNames: 'border grid xCache yCache offset cellTopLeft'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkCellScreenConverter commentStamp: 'tak 12/27/2003 16:55' prior: 0!
Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
border Number
model
grid		SkGridMorph
xCache	Array
yCache	Array
offset	Number		topLeft of the cache
screenOfset	Point
!

!SkCellScreenConverter class methodsFor: 'instance creation' stamp: 'tak 12/27/2003 15:08'!
grid: anSkGridMorph border: aNumber 
	^ self new grid: anSkGridMorph border: aNumber 
! !

!SkCellScreenConverter methodsFor: 'accessing' stamp: 'tak 12/27/2003 18:06'!
cellAreaToScreen: aRectangle topLeft: topLeft 
	^ (self cellToScreenRect: aRectangle topLeft topLeft: topLeft) topLeft - border corner: (self cellToScreenRect: aRectangle bottomRight - 1 topLeft: topLeft) bottomRight + border! !

!SkCellScreenConverter methodsFor: 'accessing' stamp: 'tak 12/27/2003 18:03'!
cellToScreenRect: aPoint topLeft: topLeft 
	| xRange yRange |
	(self extent containsPoint: aPoint)
		ifFalse: [self
				createCacheFor: (self extent
						merge: (aPoint extent: 1 @ 1))].
	xRange _ xCache at: aPoint x - (cellTopLeft x + offset x) + 1.
	yRange _ yCache at: aPoint y - (cellTopLeft y + offset y) + 1.
	^ (xRange first @ yRange first corner: xRange last @ yRange last)
		translateBy: topLeft! !

!SkCellScreenConverter methodsFor: 'private' stamp: 'tak 12/27/2003 18:02'!
createCacheFor: aRectangle 
	"xCache = #{{left. right}. {left. right}. ...}"
	| first last screenOffset |
	offset _ aRectangle topLeft - cellTopLeft.
	screenOffset _ self createOffset: offset.
	xCache _ Array new: aRectangle width.
	first _ screenOffset x + border.
	aRectangle left
		to: aRectangle right - 1
		do: [:i | 
			last _ first + (grid
							cellExtentAt: (grid globalToLocal: i @ 0)) x.
			xCache at: i - aRectangle left + 1 put: {first. last}.
			first _ last + border].
	yCache _ Array new: aRectangle height.
	first _ screenOffset y + border.
	aRectangle top
		to: aRectangle bottom - 1
		do: [:i | 
			last _ first + (grid
							cellExtentAt: (grid globalToLocal: 0 @ i)) y.
			yCache at: i - aRectangle top + 1 put: {first. last}.
			first _ last + border]! !

!SkCellScreenConverter methodsFor: 'private' stamp: 'tak 12/27/2003 15:15'!
createOffset: aPoint 
	| x y |
	x _ ((aPoint x min: 0)
				to: (aPoint x max: 0) - 1)
				inject: 0
				into: [:sub :next | sub + (grid cellExtentAt: next @ 0) x + border].
	x _ aPoint x negative
				ifTrue: [0 - x]
				ifFalse: [x].
	y _ ((aPoint y min: 0)
				to: (aPoint y max: 0) - 1)
				inject: 0
				into: [:sub :next | sub + (grid cellExtentAt: 0 @ next) y + border].
	y _ aPoint y negative
				ifTrue: [0 - y]
				ifFalse: [y].
	^ x @ y! !

!SkCellScreenConverter methodsFor: 'accessing' stamp: 'tak 12/27/2003 17:48'!
extent
	^ cellTopLeft + offset extent: xCache size @ yCache size! !

!SkCellScreenConverter methodsFor: 'initialization' stamp: 'tak 12/29/2003 11:34'!
grid: aSkGridMorph border: aNumber 
	border _ aNumber.
	grid _ aSkGridMorph.
	cellTopLeft _ aSkGridMorph visibleArea topLeft.
	self
		createCacheFor: (cellTopLeft extent: 1 @ 1)! !

!SkCellScreenConverter methodsFor: 'accessing' stamp: 'tak 12/27/2003 21:35'!
screenToCell: aPoint topLeft: topLeft 
	"Convert screen position to cell position"
	| x y right left bottom top |
	aPoint x < topLeft x
		ifTrue: [x _ self extent left - 1.
			left _ topLeft x.
			[(left _ left - (grid cellExtentAt: x @ 0) x + border) > aPoint x]
				whileTrue: [x _ x - 1]]
		ifFalse: [x _ self extent left.
			right _ topLeft x.
			[(right _ right + (grid cellExtentAt: x @ 0) x + border) < aPoint x]
				whileTrue: [x _ x + 1]].
	aPoint y < topLeft y
		ifTrue: [y _ self extent top - 1.
			top _ topLeft y.
			[(top _ top - (grid cellExtentAt: 0 @ y) y + border) > aPoint y]
				whileTrue: [y _ y - 1]]
		ifFalse: [y _ self extent top.
			bottom _ topLeft y.
			[(bottom _ bottom + (grid cellExtentAt: 0 @ y) y + border) < aPoint y]
				whileTrue: [y _ y + 1]].
	^ x @ y! !

Object subclass: #SkColorSet
	instanceVariableNames: 'basic base label selected borderStyle selectedBorderStyle plug'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

SkColorSet class
	instanceVariableNames: 'map default'!

!SkColorSet commentStamp: 'tak 12/20/2003 21:43' prior: 0!
This is a cache of color property.
!

SkColorSet class
	instanceVariableNames: 'map default'!

!SkColorSet class methodsFor: 'accessing' stamp: 'tak 1/25/2004 00:14'!
at: anObject 
	^ map
		at: anObject
		ifAbsent: [self
				projectAt: anObject
				ifAbsent: [default]]! !

!SkColorSet class methodsFor: 'query' stamp: 'tak 12/21/2003 15:10'!
baseFor: anObject
	^ (self at: anObject) base! !

!SkColorSet class methodsFor: 'query' stamp: 'tak 1/11/2004 17:44'!
basicFor: anObject
	^ (self at: anObject) basic! !

!SkColorSet class methodsFor: 'query' stamp: 'tak 12/21/2003 18:40'!
borderStyleFor: anObject
	^ (self at: anObject) borderStyle! !

!SkColorSet class methodsFor: 'accessing' stamp: 'tak 1/19/2004 08:28'!
for: anObject color: color 
	"Resist color for the morph"
	| property |
	property _ self new.
	property basic: color.
	map
		ifNil: [map _ WeakKeyDictionary new].
	map at: anObject put: property! !

!SkColorSet class methodsFor: 'accessing' stamp: 'tak 3/30/2004 22:35'!
initialize
	"It's read by system"
	"self initialize"
	map
		ifNil: [self reset]! !

!SkColorSet class methodsFor: 'query' stamp: 'tak 12/20/2003 22:15'!
labelFor: anObject
	^ (self at: anObject) label! !

!SkColorSet class methodsFor: 'accessing' stamp: 'tak 1/25/2004 00:00'!
map
	"This is temporary implementation, see SkProxy comment"
	^ map! !

!SkColorSet class methodsFor: 'query' stamp: 'tak 12/22/2003 01:22'!
plugFor: anObject 
	^ (self at: anObject) plug! !

!SkColorSet class methodsFor: 'accessing' stamp: 'tak 1/25/2004 00:12'!
projectAt: anObject ifAbsent: aBlock 
	| set colors |
	set _ SkProject current colorSet.
	set
		ifNil: [^ aBlock value].
	colors _ set
				at: anObject
				ifAbsent: [^ aBlock value].
	SkColorSet for: anObject color: colors basic.
	^ colors! !

!SkColorSet class methodsFor: 'accessing' stamp: 'tak 3/30/2004 22:35'!
reset
	"self reset"
	map := WeakKeyDictionary new.
	default := self new basic: Color blue! !

!SkColorSet class methodsFor: 'query' stamp: 'tak 12/21/2003 18:47'!
selectedBorderStyleFor: anObject
	^ (self at: anObject) selectedBorderStyle! !

!SkColorSet class methodsFor: 'query' stamp: 'tak 12/21/2003 18:45'!
selectedFor: anObject 
	^ (self at: anObject) selected! !

!SkColorSet methodsFor: 'accessing' stamp: 'tak 12/20/2003 22:02'!
base
	"Answer the value of base"

	^ base! !

!SkColorSet methodsFor: 'accessing' stamp: 'tak 1/11/2004 17:43'!
basic
	^basic! !

!SkColorSet methodsFor: 'accessing' stamp: 'tak 1/11/2004 17:30'!
basic: aColor 
	| border |
	basic _ aColor.
	label _ aColor luminance > 0.9
				ifTrue: [aColor alpha: aColor alpha]
				ifFalse: [Color
						h: aColor hue
						s: aColor saturation * 0.5
						v: aColor brightness
						alpha: aColor alpha * 0.7].
	base _ aColor luminance > 0.9
				ifTrue: [Color
						h: aColor hue
						s: 0.1
						v: aColor brightness - 0.05
						alpha: aColor alpha]
				ifFalse: [Color
						h: aColor hue
						s: 0.08
						v: (aColor brightness * 2 max: 0.8)
						alpha: aColor alpha].
	border _ aColor luminance > 0.9
				ifTrue: [Color
						h: aColor hue
						s: aColor saturation * 0.5
						v: aColor brightness - 0.2]
				ifFalse: [Color
						h: aColor hue
						s: aColor saturation * 0.5
						v: aColor brightness].
	borderStyle _ BorderStyle color: border width: 1.
	selected _ aColor luminance > 0.95
				ifTrue: [aColor]
				ifFalse: [Color
						h: base hue
						s: base saturation
						v: base brightness - 0.1].
	selectedBorderStyle _ BorderStyle color: border lighter width: 1.
	plug _ base darker! !

!SkColorSet methodsFor: 'accessing' stamp: 'tak 12/21/2003 18:38'!
borderStyle
	"Answer the value of borderStyle"

	^ borderStyle! !

!SkColorSet methodsFor: 'accessing' stamp: 'tak 12/20/2003 22:02'!
label
	"Answer the value of label"

	^ label! !

!SkColorSet methodsFor: 'accessing' stamp: 'tak 12/22/2003 01:21'!
plug
	^ plug! !

!SkColorSet methodsFor: 'accessing' stamp: 'tak 12/20/2003 22:02'!
selected
	"Answer the value of selected"

	^ selected! !

!SkColorSet methodsFor: 'accessing' stamp: 'tak 12/21/2003 18:52'!
selectedBorderStyle
	"Answer the value of border"

	^ selectedBorderStyle! !

Object subclass: #SkNullCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkNullCell commentStamp: 'tak 12/7/2003 19:53' prior: 0!
The cell object is used when a cell is not modified yet.
!

SkNullCell subclass: #SkDictionaryCell
	instanceVariableNames: 'dictionary key isKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkDictionaryCell commentStamp: 'tak 12/30/2003 00:23' prior: 0!
I am a proxy of dictionary.!

!SkDictionaryCell class methodsFor: 'instance creation' stamp: 'tak 12/30/2003 00:25'!
new
	self shouldNotImplement ! !

!SkDictionaryCell class methodsFor: 'instance creation' stamp: 'tak 12/30/2003 00:25'!
newFor: aSkDictionary key: aString 
	^ super new dictionary: aSkDictionary key: aString! !

!SkDictionaryCell methodsFor: 'accessing' stamp: 'tak 1/23/2004 23:45'!
contents
	(dictionary includesPosition: key)
		ifTrue: [key x = 1
				ifTrue: [^ (dictionary rowAt: key y) key].
			key x = 2
				ifTrue: [^ (dictionary rowAt: key y) value].
			^ ''].
	^ dictionary
		nameAt: key
		ifAbsent: ['']! !

!SkDictionaryCell methodsFor: 'accessing' stamp: 'tak 1/24/2004 08:12'!
contents: anObject 
	dictionary isLocked
		ifTrue: [^ self].
	key
		ifNil: [dictionary at: anObject asString put: '']
		ifNotNil: [self isKey
				ifTrue: [dictionary removeAt: key.
					dictionary at: anObject asString put: '']
				ifFalse: [dictionary at: key put: anObject]]! !

!SkDictionaryCell methodsFor: 'initialization' stamp: 'tak 12/30/2003 00:24'!
dictionary: aSkDictionary key: aString
	dictionary _ aSkDictionary.
	key _ aString! !

!SkDictionaryCell methodsFor: 'accessing' stamp: 'tak 1/24/2004 00:40'!
editContents: anObject 
	^ self contents: anObject! !

!SkDictionaryCell methodsFor: 'accessing' stamp: 'tak 1/24/2004 00:52'!
isKey
	^ isKey ifNil: [false]! !

!SkDictionaryCell methodsFor: 'accessing' stamp: 'tak 1/24/2004 00:51'!
isKey: aBoolean
	isKey _ aBoolean! !

!SkNullCell class methodsFor: 'accessing' stamp: 'tak 1/21/2004 08:59'!
evaluatorClass
	^ SkCompiler! !

!SkNullCell methodsFor: 'accessing' stamp: 'tak 12/29/2003 21:16'!
contents
	^ ''! !

!SkNullCell methodsFor: 'accessing' stamp: 'tak 12/29/2003 21:15'!
contents: anObject 
	^ ''! !

!SkNullCell methodsFor: 'accessing' stamp: 'tak 12/13/2003 14:52'!
editContents: aText! !

!SkNullCell methodsFor: 'accessing' stamp: 'tak 12/13/2003 15:05'!
formula
	^ nil! !

!SkNullCell methodsFor: 'accessing' stamp: 'tak 1/18/2004 15:27'!
hasCard
	^ self contents isSkObject! !

!SkNullCell methodsFor: 'accessing' stamp: 'tak 1/23/2004 01:15'!
hasFormula
	^ self formula notNil! !

!SkNullCell methodsFor: 'testing' stamp: 'tak 1/2/2004 18:23'!
hasUpdated
	^ false! !

!SkNullCell methodsFor: 'accessing' stamp: 'tak 1/16/2004 10:58'!
label
	^ nil! !

!SkNullCell methodsFor: 'accessing' stamp: 'tak 1/17/2004 22:06'!
morph
	^ nil! !

!SkNullCell methodsFor: 'accessing' stamp: 'tak 1/19/2004 19:54'!
player
	^ nil! !

!SkNullCell methodsFor: 'printing' stamp: 'tak 1/23/2004 17:18'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '('.
	aStream print: self identityHash;
		 nextPutAll: ')'! !

!SkNullCell methodsFor: 'accessing' stamp: 'tak 1/23/2004 16:50'!
privateContents
	^ self contents! !

!SkNullCell methodsFor: 'updating' stamp: 'tak 1/1/2004 15:50'!
referenceAt: aPoint
	^ #()! !

!SkNullCell methodsFor: 'accessing' stamp: 'tak 1/2/2004 20:44'!
remember
! !

!SkNullCell methodsFor: 'updating' stamp: 'tak 1/21/2004 08:47'!
resolveContextOn: holder at: pos! !

!SkNullCell methodsFor: 'updating' stamp: 'tak 1/23/2004 14:27'!
resolveFormulaOn: sheet at: aPoint 
! !

!SkNullCell methodsFor: 'updating' stamp: 'tak 12/24/2003 08:14'!
resolveOn: sheet at: aPoint 
! !

!SkNullCell methodsFor: 'accessing' stamp: 'tak 12/15/2003 18:45'!
value
	^ ''! !

SkNullCell subclass: #SkProxyCell
	instanceVariableNames: 'holderCell argCell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkProxyCell commentStamp: 'tak 12/30/2003 14:07' prior: 0!
I represent the top of cells at card model.!

!SkProxyCell methodsFor: 'accessing' stamp: 'tak 12/30/2003 14:12'!
contents
	^ holderCell contents! !

!SkProxyCell methodsFor: 'accessing' stamp: 'tak 12/30/2003 14:12'!
contents: anObject
	^ holderCell contents: anObject
! !

!SkProxyCell methodsFor: 'accessing' stamp: 'tak 1/23/2004 17:22'!
editContents: anObject 
	((anObject isString
				or: [anObject isText])
			and: [anObject first = $=])
		ifTrue: [^ argCell editContents: anObject]
		ifFalse: [^ holderCell editContents: anObject]! !

!SkProxyCell methodsFor: 'accessing' stamp: 'tak 12/30/2003 14:13'!
formula
	^ argCell formula! !

!SkProxyCell methodsFor: 'testing' stamp: 'tak 1/9/2004 08:37'!
hasUpdated
	^ holderCell hasUpdated! !

!SkProxyCell methodsFor: 'accessing' stamp: 'tak 12/30/2003 23:20'!
holderCell
	^ holderCell! !

!SkProxyCell methodsFor: 'initialization' stamp: 'tak 12/30/2003 14:08'!
holderCell: hCell argCell: aCell
	holderCell _ hCell.
	argCell _ aCell.! !

!SkProxyCell methodsFor: 'accessing' stamp: 'tak 1/23/2004 17:02'!
privateContents
	^ holderCell contents! !

!SkProxyCell methodsFor: 'updating' stamp: 'tak 1/23/2004 14:38'!
resolveFormulaOn: sheet at: aPoint 
	"I execute rule's formula.
	And chlid's card is build in this message as soon.
	So recursive call is not supported (Need more lasy solution).
"
	argCell resolveFormulaOn: sheet rule at: aPoint 
! !

SkNullCell subclass: #SkValueCell
	instanceVariableNames: 'formula block model getter setter oldValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkValueCell class methodsFor: 'instance creation' stamp: 'tak 12/13/2003 22:07'!
new
	^ super new initialize! !

!SkValueCell methodsFor: 'accessing' stamp: 'tak 12/11/2003 15:36'!
block
	^ block! !

!SkValueCell methodsFor: 'accessing' stamp: 'tak 12/29/2003 20:49'!
contents
	^ (model perform: getter) ifNil: ['']! !

!SkValueCell methodsFor: 'accessing' stamp: 'tak 1/2/2004 20:43'!
contents: anObject 
	model perform: setter with: anObject! !

!SkValueCell methodsFor: 'accessing' stamp: 'tak 1/19/2004 20:43'!
editContents: anObject 
	| string |
	(self formula: anObject)
		ifTrue: [^ self].
	anObject isNumber
		ifTrue: [^ self contents: anObject].
	string _ anObject isString
				ifTrue: [anObject]
				ifFalse: [(anObject isText
							and: [anObject unembellished])
						ifTrue: [anObject asString]].
	string
		ifNotNil: [^ self
				contents: ((self isLikeNumber: string)
						ifTrue: [string asNumber]
						ifFalse: [string])].
	self contents: anObject! !

!SkValueCell methodsFor: 'accessing' stamp: 'tak 12/11/2003 15:33'!
formula
	^ formula! !

!SkValueCell methodsFor: 'accessing' stamp: 'tak 1/21/2004 09:32'!
formula: anObject 
	"Set formula if appropriate object.  
	Answer true if fomula"
	formula _ block _ nil.
	(anObject isString
			or: [anObject isText])
		ifFalse: [^ false].
	anObject first = $=
		ifFalse: [^ false].
	formula _ anObject asString.
	block _ (Compiler new parserClass: SkParser)
				evaluate: '[:holder :pos | ' , formula allButFirst , ']'
				in: nil
				to: nil
				notifying: nil
				ifFail: [Error signal].
	^ true! !

!SkValueCell methodsFor: 'testing' stamp: 'tak 1/12/2004 23:18'!
hasUpdated
	^ self hasCard
		or: [(self contents = oldValue) not]! !

!SkValueCell methodsFor: 'initialization' stamp: 'tak 12/13/2003 22:07'!
initialize
	model _ ValueHolder new.
	setter _ #contents:.
	getter _ #contents! !

!SkValueCell methodsFor: 'support' stamp: 'tak 12/30/2003 11:58'!
isLikeNumber: aString
	" 
	self new isLikeNumber: '0'   
	self new isLikeNumber: '-3.141592'   
	self new isLikeNumber: 'word'  
	self new isLikeNumber: '10a'  
	"
	^ aString = ([aString asNumber] on: Error do: [0]) asString! !

!SkValueCell methodsFor: 'testing' stamp: 'tak 1/24/2004 18:03'!
isNull
	^ block isNil
		and: [self contents = '']! !

!SkValueCell methodsFor: 'accessing' stamp: 'tak 1/16/2004 10:55'!
label
	^ (self contents isKindOf: Player)
		ifTrue: [self contents externalName]
		ifFalse: [(model isKindOf: Player)
				ifTrue: [self slotName]]! !

!SkValueCell methodsFor: 'updating' stamp: 'tak 1/25/2004 12:25'!
modelAddDependent: anObject 
	model addDependent: anObject! !

!SkValueCell methodsFor: 'updating' stamp: 'tak 1/25/2004 12:24'!
modelRemoveDependent: anObject
	model removeDependent: anObject! !

!SkValueCell methodsFor: 'accessing' stamp: 'tak 12/13/2003 13:31'!
on: anObject getter: getSelector setter: setSelector 
	model _ anObject.
	getter _ getSelector.
	setter _ setSelector! !

!SkValueCell methodsFor: 'accessing' stamp: 'tak 1/18/2004 00:39'!
player
	(self contents isKindOf: Player)
		ifTrue: [^ self contents].
	(model isKindOf: Player)
		ifTrue: [^ model].
	^ super morph! !

!SkValueCell methodsFor: 'printing' stamp: 'tak 1/24/2004 23:49'!
printOn: aStream 
	aStream nextPutAll: '[' , self contents printString , ' | ' , formula printString , ']'.
	aStream nextPutAll: '('.
	aStream print: self identityHash;
		 nextPutAll: ')'! !

!SkValueCell methodsFor: 'updating' stamp: 'tak 1/18/2004 19:58'!
referenceAt: aPoint 
	| finder |
	^ self hasCard
		ifTrue: [(self hasCard
					and: [self contents isInstance])
				ifTrue: [(self contents referenceAt: aPoint) asSet]
				ifFalse: [#()]]
		ifFalse: [finder _ SkRefFinder new.
			self resolveOn: finder at: aPoint.
			finder keys]! !

!SkValueCell methodsFor: 'accessing' stamp: 'tak 1/2/2004 20:43'!
remember
	oldValue _ self contents! !

!SkValueCell methodsFor: 'updating' stamp: 'tak 1/23/2004 19:31'!
resolveCardOn: sheet at: aPoint 
	| ruleCase privateCase |
	ruleCase _ self contents.
	privateCase _ (sheet assuredCellAt: aPoint) privateContents.
	ruleCase = sheet
		ifTrue: [^ self].
	(privateCase isSkObject
			and: [ruleCase rule = privateCase rule])
		ifFalse: [privateCase _ block value: sheet value: aPoint.
			sheet at: aPoint put: privateCase.
			privateCase holder: sheet at: aPoint.
			self changed: #cardList].
	privateCase resolveOn: sheet! !

!SkValueCell methodsFor: 'updating' stamp: 'tak 4/11/2004 01:11'!
resolveFormulaOn: sheet at: aPoint 
	block
		ifNil: [^ self].
	sheet
		at: aPoint
		put: ([block value: sheet value: aPoint]
				ifError: [:err :rcvr | 
					false
						ifTrue: [Transcript show: err printString;
								 cr;
								 show: rcvr printString;
								 cr].
					0])! !

!SkValueCell methodsFor: 'updating' stamp: 'tak 1/23/2004 14:29'!
resolveOn: sheet at: aPoint
	"Execute card if I have already had card
	Execute formula if I doesn't have card"
	self hasFormula
		ifTrue: [self hasCard
				ifTrue: [self resolveCardOn: sheet at: aPoint]
				ifFalse: [self resolveFormulaOn: sheet at: aPoint]]! !

!SkValueCell methodsFor: 'accessing' stamp: 'Richo 10/18/2011 12:03'!
slotName
	"See Player>>tearOffFancyWatcherFor:"
	| info watcherWording anInterface |
	info _ model slotInfoForGetter: getter.
	info
		ifNil: [anInterface _ Vocabulary eToyVocabulary
						methodInterfaceAt: getter
						ifAbsent: [].
			watcherWording _ anInterface wording]
		ifNotNil: [watcherWording _ Utilities inherentSelectorForGetter: getter].
	^ model tileReferringToSelf bePossessive labelMorph contents , ' ' , watcherWording! !

!SkValueCell methodsFor: 'accessing' stamp: 'tak 12/7/2003 22:46'!
sourceCode
	| code |
	code := block sourceCode.
	^ code copyFrom: (code indexOf: $[)
			+ 1 to: (code lastIndexOf: $])
			- 1! !

!SkValueCell methodsFor: 'coping' stamp: 'tak 1/28/2004 23:08'!
veryDeepInner: deepCopier 
	"block is not copied"
	model _ model veryDeepCopyWith: deepCopier.
	getter _ getter veryDeepCopyWith: deepCopier.
	setter _ setter veryDeepCopyWith: deepCopier.
	oldValue _ oldValue veryDeepCopyWith: deepCopier.
! !

Object subclass: #SkObject
	instanceVariableNames: ''
	classVariableNames: 'NullCell Root'
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkObject commentStamp: 'tak 1/11/2004 13:57' prior: 0!
I am a base class of Skeleton object.!

SkObject subclass: #SkLibrary
	instanceVariableNames: 'args direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

SkLibrary subclass: #SkAverage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base-Sheet'!

!SkAverage class methodsFor: 'instance creation' stamp: 'tak 1/27/2004 09:53'!
defaultColor
	^ (TranslucentColor r: 0.484 g: 0.806 b: 0.0 alpha: 0.667)! !

!SkAverage methodsFor: 'updating' stamp: 'tak 1/27/2004 09:54'!
resolve
	| elements |
	args size < 2 ifTrue: [^self].
	elements _ args allButFirst
			collect: [:each | each contents].
	args first contents: (elements sum) / elements size! !

SkLibrary subclass: #SkCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base-Sheet'!

!SkCopy methodsFor: 'updating' stamp: 'tak 1/22/2004 16:02'!
resolve
	| first |
	args isEmpty
		ifTrue: [^ self].
	first _ args first contents.
	args allButFirst
		do: [:each | each contents: first copy]! !

SkLibrary subclass: #SkCount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base-Sheet'!

!SkCount class methodsFor: 'instance creation' stamp: 'tak 1/18/2004 20:18'!
defaultColor
	^(TranslucentColor r: 0.226 g: 0.258 b: 1.0 alpha: 0.812)! !

!SkCount methodsFor: 'updating' stamp: 'tak 1/18/2004 20:17'!
resolve
	args withIndexDo: [ :each :index | each contents: index].
! !

SkLibrary subclass: #SkDistance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base-Sheet'!

!SkDistance class methodsFor: 'instance creation' stamp: 'tak 1/18/2004 20:30'!
defaultColor
	^ (TranslucentColor r: 0.806 g: 0.0 b: 0.065 alpha: 0.745)! !

!SkDistance methodsFor: 'initialization' stamp: 'tak 1/18/2004 20:42'!
initialize
	super initialize.
	args _ {SkValueCell new. SkValueCell new. SkValueCell new}! !

!SkDistance methodsFor: 'updating' stamp: 'tak 1/18/2004 20:31'!
resolve
	| m1 m2 distance |
	args size < 3
		ifTrue: [^ self].
	m1 _ (args first contents isKindOf: Player)
				ifTrue: [args first contents costume]
				ifFalse: [^ self].
	m2 _ (args second contents isKindOf: Player)
				ifTrue: [args second contents costume]
				ifFalse: [^ self].
	distance _ args third contents isNumber
				ifTrue: [args third contents]
				ifFalse: [^ self].
	self
		setDistanceFrom: m1
		to: m2
		distance: distance! !

!SkDistance methodsFor: 'updating' stamp: 'tak 1/19/2004 20:31'!
setDistanceFrom: m1 to: m2 distance: distance 
	| goal |
	goal _ m1 position direction2: m2 position distance: distance.
	m2 position: goal.
! !

!SkDistance methodsFor: 'accessing' stamp: 'tak 1/18/2004 20:42'!
size: aNumber 
! !

!SkDistance methodsFor: 'updating' stamp: 'tak 1/18/2004 20:33'!
wantsUpdate
	^ true! !

!SkLibrary class methodsFor: 'planning' stamp: 'tak 1/18/2004 16:23'!
collectDependents
	^ #()! !

!SkLibrary class methodsFor: 'instance creation' stamp: 'tak 1/18/2004 19:44'!
defaultColor
	^ TranslucentColor
		r: 0.0
		g: 0.71
		b: 0.806
		alpha: 0.745! !

!SkLibrary class methodsFor: 'instance creation' stamp: 'tak 1/18/2004 15:52'!
direction: aSymbol
	^self new direction: aSymbol! !

!SkLibrary class methodsFor: 'instance creation' stamp: 'tak 1/18/2004 16:40'!
direction: direction size: aNumber 
	| instance |
	instance _ self new.
	instance direction: direction.
	instance size: aNumber.
	^ instance! !

!SkLibrary class methodsFor: 'testing' stamp: 'tak 1/18/2004 20:10'!
wantsUpdate
	^ false! !

!SkLibrary methodsFor: 'arg accessing' stamp: 'tak 1/18/2004 19:09'!
argPositions
	^ (1 to: args size)
		collect: [:index | index @ 1]! !

!SkLibrary methodsFor: 'accessing' stamp: 'tak 1/20/2004 16:11'!
args
	^ args! !

!SkLibrary methodsFor: 'structure' stamp: 'tak 1/20/2004 22:07'!
attachProject
! !

!SkLibrary methodsFor: 'cell accessing' stamp: 'tak 1/18/2004 16:20'!
cardList: aRectangle
	^ #()! !

!SkLibrary methodsFor: 'cell accessing' stamp: 'tak 1/18/2004 19:19'!
cellAt: key ifAbsent: aBlock 
	key class = Point
		ifTrue: [key y = 1
				ifTrue: [key x <= args size
						ifTrue: [^ args at: key x ifAbsent: aBlock]]].
	^ aBlock value! !

!SkLibrary methodsFor: 'accessing' stamp: 'tak 1/18/2004 16:37'!
direction
	^ direction! !

!SkLibrary methodsFor: 'accessing' stamp: 'tak 1/18/2004 16:37'!
direction: aSymbol 
	direction _ aSymbol! !

!SkLibrary methodsFor: 'holder and card' stamp: 'tak 1/25/2004 12:51'!
holder: aSkSheet at: aPoint 
	| holderCell |
	self initializeArgs.
	(self referenceAt: aPoint)
		withIndexDo: [:pos :index | 
			holderCell _ aSkSheet assuredCellAt: pos.
			holderCell modelAddDependent: self.
			args at: index put: holderCell].
	self update: #contents.! !

!SkLibrary methodsFor: 'initialization' stamp: 'tak 1/25/2004 12:18'!
initialize
	super initialize.
	self initializeArgs.
	direction _ #right.
! !

!SkLibrary methodsFor: 'initialization' stamp: 'tak 1/25/2004 12:41'!
initializeArgs
	args
		ifNil: [args _ #()]
		ifNotNil: [args
				do: [:each | each class = SkValueCell
						ifTrue: [each modelRemoveDependent: self]]]! !

!SkLibrary methodsFor: 'initialization' stamp: 'tak 1/25/2004 12:37'!
initializeArgs: aNumber 
	self initializeArgs.
	args _ Array new: aNumber.
	args
		withIndexDo: [:each :index | 
			| cell | 
			cell _ SkValueCell new.
			cell modelAddDependent: self.
			args at: index put: cell]! !

!SkLibrary methodsFor: 'structure' stamp: 'tak 1/18/2004 17:30'!
parent
	^ self rule parent! !

!SkLibrary methodsFor: 'arg accessing' stamp: 'tak 1/18/2004 19:09'!
referenceAt: aPoint 
	"Answer the dependents object's point"
	^ self argPositions
		collect: [:each | self pointForHolder: aPoint at: each]! !

!SkLibrary methodsFor: 'holder and card' stamp: 'tak 1/25/2004 16:59'!
releaseHolder
	self initializeArgs: 3.
	super releaseHolder! !

!SkLibrary methodsFor: 'updating' stamp: 'tak 1/18/2004 19:39'!
resolve! !

!SkLibrary methodsFor: 'updating' stamp: 'tak 4/11/2004 01:11'!
resolveOn: sheet 
	[self resolve]
		ifError: [:err :rcvr | 
			false
				ifTrue: [Transcript show: err printString;
						 cr;
						 show: rcvr printString;
						 cr].
			0]! !

!SkLibrary methodsFor: 'structure' stamp: 'tak 1/18/2004 15:57'!
rule
	^ self class! !

!SkLibrary methodsFor: 'accessing' stamp: 'tak 1/18/2004 19:01'!
size
	^ args size! !

!SkLibrary methodsFor: 'accessing' stamp: 'tak 1/18/2004 19:24'!
size: aNumber 
	args _ Array new: aNumber.
	args _ args
				collect: [:each | SkValueCell new]! !

!SkLibrary methodsFor: 'updating' stamp: 'tak 1/20/2004 22:06'!
wantsSteps
	^ true! !

SkLibrary subclass: #SkName
	instanceVariableNames: 'holder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base-Sheet'!

!SkName class methodsFor: 'instance creation' stamp: 'tak 1/18/2004 20:45'!
defaultColor
	^ (TranslucentColor r: 0.581 g: 0.581 b: 0.581 alpha: 0.682)! !

!SkName methodsFor: 'accessing' stamp: 'tak 1/18/2004 23:37'!
cell
	^ args second! !

!SkName methodsFor: 'arg accessing' stamp: 'tak 1/19/2004 08:55'!
holder: aSkSheet at: aPoint 
	super holder: aSkSheet at: aPoint.
	holder _ aSkSheet.
	holder updateKeys! !

!SkName methodsFor: 'initialization' stamp: 'tak 1/18/2004 23:38'!
initialize
	super initialize.
	args _ {SkValueCell new. SkValueCell new}! !

!SkName methodsFor: 'accessing' stamp: 'tak 1/18/2004 23:44'!
key
	^ args first contents! !

!SkName methodsFor: 'holder and card' stamp: 'tak 1/25/2004 14:42'!
releaseHolder
	holder removeAt: self key.
	holder updateKeys.
	super releaseHolder! !

!SkName methodsFor: 'updating' stamp: 'tak 1/18/2004 23:41'!
resolve
	args first hasUpdated ifTrue: [holder updateKeys]! !

!SkName methodsFor: 'accessing' stamp: 'tak 1/18/2004 23:38'!
size: aNumber 
! !

SkLibrary subclass: #SkSum
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base-Sheet'!

!SkSum class methodsFor: 'instance creation' stamp: 'tak 1/18/2004 20:05'!
defaultColor
	^ (TranslucentColor r: 0.484 g: 0.806 b: 0.0 alpha: 0.667)! !

!SkSum methodsFor: 'updating' stamp: 'tak 1/18/2004 19:41'!
resolve
	args first contents: (args allButFirst
			collect: [:each | each contents]) sum! !

SkObject subclass: #SkNamed
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkNamed commentStamp: 'tak 1/11/2004 13:58' prior: 0!
I am a abstract class of Skeleton object that has a name.

parent	SkObject!

SkNamed subclass: #SkMap
	instanceVariableNames: 'map'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

SkMap subclass: #SkCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkCollection commentStamp: 'tak 1/22/2004 08:41' prior: 0!
SkCollection open!

!SkCollection methodsFor: 'accessing' stamp: 'tak 1/24/2004 10:35'!
add: anObject
	map add: anObject.
	self changed: #cardList.! !

!SkCollection methodsFor: 'accessing' stamp: 'tak 1/24/2004 11:28'!
cardPositions
	^ (1 to: map size)
		collect: [:each | 1 @ (each + 1)]! !

!SkCollection methodsFor: 'cell accessing' stamp: 'tak 1/24/2004 11:25'!
cellAt: key ifAbsent: aBlock 
	| contents |
	(self isApplicableKey: key)
		ifTrue: [contents _ map at: (key - 1) y ifAbsent: aBlock.
			^ SkValueCell new contents: contents]
		ifFalse: [^ aBlock value]! !

!SkCollection methodsFor: 'enumrating' stamp: 'tak 1/24/2004 10:53'!
do: aBlock
	map do: aBlock! !

!SkCollection methodsFor: 'testing' stamp: 'tak 1/24/2004 10:58'!
includes: anObject 
	^ map includes: anObject! !

!SkCollection methodsFor: 'initialization' stamp: 'tak 1/22/2004 08:43'!
initialize
	super initialize.
	map _ OrderedCollection new.
! !

!SkCollection methodsFor: 'testing' stamp: 'tak 1/24/2004 11:25'!
isApplicableKey: anObject 
	anObject class == Point
		ifFalse: [^ false].
	anObject x = 1
		ifFalse: [^ false].
	(anObject y < 2
			or: [anObject y > (map size + 1)])
		ifTrue: [^ false].
	^ true! !

!SkCollection methodsFor: 'testing' stamp: 'tak 1/24/2004 14:29'!
isInstance
"maybe bad"
	^ false! !

!SkCollection methodsFor: 'testing' stamp: 'tak 1/27/2004 13:14'!
isStepList
	^ self ruleName = 'StepList'! !

!SkCollection methodsFor: 'updating' stamp: 'tak 1/27/2004 13:15'!
isStepping
	(self isStepList
			and: [map isEmpty not])
		ifTrue: [^ true].
	^ super isStepping! !

!SkCollection methodsFor: 'cell accessing' stamp: 'tak 1/24/2004 14:45'!
removeAt: key 
	(self isApplicableKey: key)
		ifFalse: [^ NullCell].
	map removeAt: key y - 1.
	self changed: #cardList.
	^ NullCell! !

!SkCollection methodsFor: 'accessing' stamp: 'tak 1/24/2004 10:49'!
remove: value 
	map
		removeAllSuchThat: [:each | each = value].
	self changed: #cardList.
	^ value! !

!SkCollection methodsFor: 'updating' stamp: 'tak 1/27/2004 13:16'!
stopStepping
	map _ OrderedCollection new.
	self changed: #cardList.
! !

SkMap subclass: #SkDictionary
	instanceVariableNames: 'comment orderedCache args'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkDictionary commentStamp: 'tak 12/22/2003 16:11' prior: 0!
This is a dictionary like rule.!

!SkDictionary methodsFor: 'arg accessing' stamp: 'tak 1/24/2004 13:15'!
argPositions
	^ (1 to: self args size)
		collect: [:index | index @ 1]! !

!SkDictionary methodsFor: 'accessing' stamp: 'tak 1/24/2004 13:14'!
args
	^ args
		ifNil: [self initializeArgs]! !

!SkDictionary methodsFor: 'cell accessing' stamp: 'tak 1/24/2004 01:05'!
assuredCellAt: key 
	(self includesArgs: key)
		ifTrue: [^ args at: key x].
	(self includesPosition: key)
		ifTrue: [key x = 1
				ifTrue: [^ (SkDictionaryCell newFor: self key: (self rowAt: key y) key)
						isKey: true]
				ifFalse: [^ SkDictionaryCell newFor: self key: (self rowAt: key y) key]].
	^ key class == Point
		ifTrue: [SkDictionaryCell newFor: self key: nil]
		ifFalse: [SkDictionaryCell newFor: self key: key]! !

!SkDictionary methodsFor: 'accessing' stamp: 'tak 12/30/2003 08:37'!
at: key put: anObject
	self flag: #TODO.
	map at: key put: anObject.
	self updateCache.
	^ anObject! !

!SkDictionary methodsFor: 'accessing' stamp: 'tak 1/24/2004 00:16'!
cardPositions
	^ (1 to: orderedCache size + 1)
		collect: [:each | 2 @ each]
		thenSelect: [:key | (self at: key) isSkObject]! !

!SkDictionary methodsFor: 'cell accessing' stamp: 'tak 1/24/2004 13:41'!
cellAt: key ifAbsent: aBlock 
	"Evaluate aBlock when not found and key is not point"
	(self includesArgs: key)
		ifTrue: [^ self args at: key x].
	(self includesPosition: key)
		ifTrue: [^ SkDictionaryCell newFor: self key: key].
	(map includesKey: key)
		ifTrue: [^ SkDictionaryCell newFor: self key: key]
		ifFalse: [^ aBlock value]! !

!SkDictionary methodsFor: 'accessing' stamp: 'tak 1/23/2004 23:02'!
defaultArea
	^ 0 @ 0 extent: 3 @ (self namesSize + 1)! !

!SkDictionary methodsFor: 'arg accessing' stamp: 'tak 1/24/2004 00:07'!
holder: aSkSheet at: aPoint 
	| holderCell |
	(self referenceAt: aPoint)
		withIndexDo: [:pos :index | 
			holderCell _ aSkSheet assuredCellAt: pos.
			args at: index put: holderCell]! !

!SkDictionary methodsFor: 'testing' stamp: 'tak 1/23/2004 23:59'!
includesArgs: aPoint 
	^ {1 @ 1. 2 @ 1} includes: aPoint! !

!SkDictionary methodsFor: 'testing' stamp: 'tak 1/23/2004 23:40'!
includesPosition: aPoint 
	aPoint class == Point
		ifFalse: [^ false].
	aPoint y < 2
		ifTrue: [^ false].
	aPoint y > (map size + 1)
		ifTrue: [^ false].
	(#(1 2 ) includes: aPoint x)
		ifFalse: [^ false].
	^ true! !

!SkDictionary methodsFor: 'initialization' stamp: 'tak 1/23/2004 23:50'!
initialize
	super initialize.
	map _ Dictionary new.
	comment _ '' asText.
	self updateCache.
	self initializeArgs! !

!SkDictionary methodsFor: 'initialization' stamp: 'tak 1/24/2004 13:14'!
initializeArgs
	^ args _ {SkValueCell new. SkValueCell new}! !

!SkDictionary methodsFor: 'testing' stamp: 'tak 1/24/2004 08:20'!
isLocked
	^ map includesKey: 'locked'! !

!SkDictionary methodsFor: 'structure' stamp: 'tak 12/28/2003 12:04'!
keyAtValue: anObject ifAbsent: aBlock 
	^ map keyAtValue: anObject ifAbsent: aBlock! !

!SkDictionary methodsFor: 'accessing' stamp: 'tak 1/24/2004 08:20'!
locked: boolean.
	map at: 'locked' put: boolean! !

!SkDictionary methodsFor: 'accessing' stamp: 'tak 12/30/2003 07:49'!
nameAt: key ifAbsent: aBlock 
	^ map at: key ifAbsent: aBlock! !

!SkDictionary methodsFor: 'accessing' stamp: 'tak 12/30/2003 08:13'!
namesSize
	^ map size! !

!SkDictionary methodsFor: 'arg accessing' stamp: 'tak 1/24/2004 00:08'!
referenceAt: aPoint 
	"Answer the dependents object's point"
	^ self argPositions
		collect: [:each | self pointForHolder: aPoint at: each]! !

!SkDictionary methodsFor: 'structure' stamp: 'tak 1/24/2004 16:36'!
removeAt: key 
	| cell name |
	name _ key class == Point
				ifTrue: [(self rowAt: key y) key]
				ifFalse: [key].
	self isLocked
		ifTrue: [^ self cellAt: name].
	cell _ super removeAt: name.
	self updateCache.
	self update: #cardList.
	^ cell! !

!SkDictionary methodsFor: 'structure' stamp: 'tak 1/24/2004 17:29'!
removeForce: key 
	map removeKey: key ifAbsent: []! !

!SkDictionary methodsFor: 'updating' stamp: 'tak 1/24/2004 00:18'!
resolveOn: holder 
	| value |
	(value _ map
					at: args first contents
					ifAbsent: [args second contents: ''.
						^ self]) = args second contents
		ifFalse: [args second contents: value.
			holder changed: #cardList.
			self changed: #cardList]! !

!SkDictionary methodsFor: 'accessing' stamp: 'tak 1/23/2004 23:23'!
rowAt: aNumber 
	^ (1 < aNumber
			and: [aNumber <= (orderedCache size + 1)])
		ifTrue: [orderedCache at: aNumber - 1]! !

!SkDictionary methodsFor: 'accessing' stamp: 'tak 1/24/2004 00:01'!
size
	^ 2! !

!SkDictionary methodsFor: 'accessing' stamp: 'tak 12/30/2003 09:03'!
updateCache
	orderedCache _ SortedCollection
				sortBlock: [:x :y | x key name <= y key name].
	map
		associationsDo: [:assoc | orderedCache add: assoc]! !

!SkDictionary methodsFor: 'updating' stamp: 'tak 1/24/2004 00:47'!
wantsSteps
	^ true! !

SkDictionary subclass: #SkProject
	instanceVariableNames: 'colorSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkProject commentStamp: 'tak 1/25/2004 00:00' prior: 0!
I hold all spreadsheets in a project.
I find my parent from class variable but instance variable.
This is because to aviod copy all trees when I am saved into project file.

colorSet -- SkColorSet ... This is temporary implementation. It is bounded to save as project.!

!SkProject class methodsFor: 'accessing' stamp: 'tak 1/24/2004 13:56'!
current
	^ self for: Project current! !

!SkProject class methodsFor: 'accessing' stamp: 'tak 1/25/2004 00:22'!
forceRemoveAt: aProject 
	"remove for debug"
	"self forceRemoveAt: Project current"
	(SkDictionary allInstances
		select: [:each | each includesKey: aProject])
		do: [:each | each removeForce: aProject]! !

!SkProject class methodsFor: 'accessing' stamp: 'tak 1/24/2004 14:05'!
for: aProject 
	"SkProject for: (Project named: 'Unnamed1')"
	| parent dict |
	parent _ self root at: 'Projects'.
	dict _ parent
				at: aProject
				ifAbsent: [(SkProject newFor: aProject) parent: parent;
						 name: aProject].
	^ dict! !

!SkProject class methodsFor: 'accessing' stamp: 'tak 1/24/2004 13:33'!
newFor: aProject 
	"find this instance for the project. little tricky"
	"self findProject: Project current"
	| map |
	map _ SkDictionary allInstances
				detect: [:each | each includesKey: aProject]
				ifNone: [^ self new].
	^ map at: aProject! !

!SkProject methodsFor: 'accessing' stamp: 'tak 1/25/2004 00:09'!
colorSet
	^colorSet! !

!SkProject methodsFor: 'initialization' stamp: 'tak 1/25/2004 00:01'!
initialize
	super initialize.
	colorSet _ SkColorSet map! !

!SkProject methodsFor: 'structure' stamp: 'tak 1/11/2004 11:24'!
parent
	^ self class root findName: 'Projects'! !

!SkProject methodsFor: 'structure' stamp: 'tak 1/11/2004 11:25'!
parent: aSkObject
	"do nothing"
	^ self! !

!SkProject methodsFor: 'accessing' stamp: 'tak 1/24/2004 11:22'!
stepList
	^ self
		at: 'StepList'
		ifAbsent: [| list | 
			list _ SkCollection new.
			self at: 'StepList' put: list.
			list parent: self.
			World setProperty: #SkStepList toValue: list.
			list]! !

!SkMap methodsFor: 'structure' stamp: 'tak 12/30/2003 19:11'!
removeAt: key
	| cell |
	cell _ self cellAt: key.
	map
		removeKey: key
		ifAbsent: [].
	^ cell! !

SkMap subclass: #SkSheet
	instanceVariableNames: 'plan dependMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkSheet commentStamp: 'tak 4/2/2004 21:27' prior: 0!
I am a simple spreadsheets model.

Preferences enable: #batchPenTrails
SkSheet example

Structure:
 dictionary		Dictionary -- reference of cells
!

!SkSheet class methodsFor: 'examples' stamp: 'tak 4/2/2004 21:27'!
example
	"self example"
	| sheet p1 p2 |
	ActiveWorld setProperty: #originAtCenter toValue: true.
	sheet _ SkSheet new.
	p1 _ (SkeletonBaseInfo point color: Color blue) openInWorld assuredPlayer.
	p2 _ (SkeletonBaseInfo point color: Color red) openInWorld assuredPlayer.
	sheet
		modelAt: 1 @ 1
		for: p1
		getter: #getX
		setter: #setX:.
	sheet
		modelAt: 2 @ 1
		for: p1
		getter: #getY
		setter: #setY:.
	sheet
		modelAt: 1 @ 2
		for: p2
		getter: #getX
		setter: #setX:.
	sheet
		modelAt: 2 @ 2
		for: p2
		getter: #getY
		setter: #setY:.
	sheet textAt: 1 @ 1 put: '=( 4 * A2 ) degreeSin * 200'.
	sheet textAt: 2 @ 1 put: '=( 7 * A2 ) degreeSin * 200'.
	p1 setPenDown: true.
	p1
		setPenColor: (TranslucentColor
				r: 1.0
				g: 0.0
				b: 0.0
				alpha: 0.1).
	p1 setPenSize: 3.
	p2 setX: 0;
		 setY: 0.
	sheet grid openInWorld! !

!SkSheet methodsFor: 'cell accessing' stamp: 'tak 12/30/2003 08:58'!
assuredCellAt: key 
	^ self
		cellAt: key
		ifAbsent: [map at: key put: SkValueCell new]! !

!SkSheet methodsFor: 'accessing' stamp: 'tak 1/23/2004 18:38'!
cardList: aRectangle 
	^ self cardPositions
		collect: [:key | key
				-> (self at: key)]! !

!SkSheet methodsFor: 'planning' stamp: 'tak 1/9/2004 14:19'!
cardPositions
	^ map keys
		select: [:each | each class = Point
				and: [(map at: each) hasCard]]! !

!SkSheet methodsFor: 'cell accessing' stamp: 'tak 12/28/2003 17:50'!
cellAt: key ifAbsent: aBlock 
	^ map at: key ifAbsent: aBlock! !

!SkSheet methodsFor: 'updating' stamp: 'tak 1/24/2004 18:06'!
cleaning
	(map keys
		select: [:key | (map at: key) isNull
				and: [(dependMap keys includes: key) not]])
		do: [:key | map removeKey: key]! !

!SkSheet methodsFor: 'planning' stamp: 'tak 1/18/2004 20:02'!
collectCardDependents: depArray 
	"Answer  
	#((observer subject subject ..) .."
	"This is ugly code because using Array. We should use Dictionary by  
	building plan"
	| dict |
	dict _ Dictionary new.
	depArray
		do: [:each | dict at: each first put: each allButFirst asSet].
	(self cardPositions
		select: [:each | (map at: each) contents isInstance])
		do: [:each | ((map at: each) contents collectDependentsForCard: each)
				ifNotNilDo: [:depends | depends
						keysAndValuesDo: [:key :value | (dict at: key ifAbsentPut: Set new)
								addAll: value]]].
	^ self dictToArray: dict! !

!SkSheet methodsFor: 'planning' stamp: 'tak 1/9/2004 15:28'!
collectDependents
	"Answer 
	#((observer subject subject ..) 
	(observer subject subject ..) 
	(observer subject subject ..))"
	| node myDepends |
	myDepends _ self collectTargets
				collect: [:point | 
					node _ ((self cellAt: point)
								referenceAt: point)
								asSortedCollection: self sortBlock.
					node _ node asOrderedCollection addFirst: point;
								 yourself.
					node asArray].
	^ self collectCardDependents: myDepends! !

!SkSheet methodsFor: 'planning' stamp: 'tak 1/7/2004 18:05'!
collectOrder
	| trees |
	trees _ self collectTrees.
	^ trees
		inject: OrderedCollection new
		into: [:order :next | order
				addAll: (self collectOrder: next);
				 yourself]! !

!SkSheet methodsFor: 'planning' stamp: 'tak 1/2/2004 14:43'!
collectOrder: tree 
	tree isCollection
		ifFalse: [^ Array with: tree].
	^ Array
		streamContents: [:aStream | 
			tree allButFirst
				do: [:node | aStream
						nextPutAll: (self collectOrder: node)].
			aStream nextPut: tree first]! !

!SkSheet methodsFor: 'planning' stamp: 'tak 1/2/2004 12:25'!
collectTargets
	"Answer points that has formula or card"
	^ ((map keys
		select: [:key | key class = Point
				and: [(map at: key) hasFormula]])
		asSortedCollection: self sortBlock) asArray! !

!SkSheet methodsFor: 'planning' stamp: 'tak 1/9/2004 17:08'!
collectTrees
	"Adopt parted node (collectDependents) into a big tree"
	"The order is important"
	| pool newNodes isFound |
	"pool is a map of observer -> subjects"
	pool _ self collectDependents.
	newNodes _ OrderedCollection new.
	pool
		do: [:node | 
			isFound _ false.
			(pool copyWithout: node)
				do: [:mother | (self hasRecursion: mother first in: node)
						ifFalse: [2
								to: mother size
								do: [:index | (isFound not
											and: [(mother at: index)
													= node first])
										ifTrue: [mother at: index put: node.
											isFound _ true]]]].
			isFound
				ifFalse: [newNodes add: node]].
	^ newNodes asArray! !

!SkSheet methodsFor: 'planning' stamp: 'tak 1/9/2004 16:26'!
dependMap
	"directory of (subject -> a set of observers)"
	| dep values |
	dep _ Dictionary new.
	"Make simple dictionary reverse of dependents #(observers  subject ..)"
	self collectDependents
		do: [:each | each allButFirst
				do: [:point | 
					values _ dep at: point ifAbsentPut: Set new.
					values add: each first]].
	dep keys
		do: [:key | self
				dependMap: key
				addKey: (dep at: key)
				dict: dep].
	^ dep! !

!SkSheet methodsFor: 'planning' stamp: 'tak 1/7/2004 17:33'!
dependMap: target addKey: addKey dict: dict 
	| founds more |
	founds _ Set with: target.
	founds
		addAll: (dict at: target).
	more _ Set new.
	addKey
		do: [:key | more
				addAll: ((dict
						at: key
						ifAbsent: [#()])
						select: [:value | (founds includes: value) not])].
	more isEmpty
		ifTrue: [^ self].
	(dict at: target)
		addAll: more.
	self
		dependMap: target
		addKey: more
		dict: dict! !

!SkSheet methodsFor: 'planning' stamp: 'tak 1/9/2004 15:27'!
dictToArray: aDictionary 
	" 
	(self new dictToArray: (Dictionary new  
	at: 1@2 put: (Set new addAll: {2@2. 3@2});
	at: 1@1 put: (Set new addAll: {3@1. 2@1});  
	yourself)) = {{1@1. 2@1. 3@1}.{1@2. 2@2. 3@2}} 
	"
	| set line |
	^ ((aDictionary keys asSortedCollection: self sortBlock)
		collect: [:key | 
			line _ OrderedCollection new.
			line add: key.
			set _ aDictionary at: key.
			line
				addAll: (set asSortedCollection: self sortBlock).
			line asArray]) asArray! !

!SkSheet methodsFor: 'initialization' stamp: 'tak 1/24/2004 13:01'!
grid
	self startStepping.
	^ super grid! !

!SkSheet methodsFor: 'planning' stamp: 'tak 1/8/2004 20:55'!
hasRecursion: aPoint in: node 
	"(self new hasRecursion: 1@1 in: {2@2. {1@1. 2@2}}) = true"
	"(self new hasRecursion: 1@1 in: {3@3. {2@2. 1@1}}) = false"
	^ node first = aPoint
		or: [node allButFirst
				anySatisfy: [:each | each isCollection
						and: [self hasRecursion: aPoint in: each]]]! !

!SkSheet methodsFor: 'initialization' stamp: 'tak 1/7/2004 18:11'!
initialize
	super initialize.
	map _ Dictionary new.
	plan _ #()! !

!SkSheet methodsFor: 'holder and card' stamp: 'tak 1/23/2004 19:29'!
installFormulaAt: aPoint 
	| cell card |
	(cell _ self cellAt: aPoint) hasCard
		ifTrue: [card _ cell contents.
			card isInstance
				ifTrue: [card holder: self at: aPoint].
			self changed: #cardList.].
	self updatePlan.
	self changed! !

!SkSheet methodsFor: 'testing' stamp: 'tak 1/23/2004 21:47'!
isInstance
	^ false! !

!SkSheet methodsFor: 'structure' stamp: 'tak 1/16/2004 16:46'!
keyAtValue: value ifAbsent: aBlock 
	"Answer only named key"
	map
		associationsDo: [:association | (value == association value contents
					and: [association key class ~= Point])
				ifTrue: [^ association key]].
	^ aBlock value! !

!SkSheet methodsFor: 'accessing' stamp: 'tak 12/20/2003 12:51'!
modelAt: aPoint for: anObject getter: getter setter: setter 
	self
		textAt: aPoint
		put: (anObject perform: getter).
	(self cellAt: aPoint)
		on: anObject
		getter: getter
		setter: setter.
! !

!SkSheet methodsFor: 'cell accessing' stamp: 'tak 12/30/2003 23:44'!
nameAt: aString putCell: cell
	map at: aString put: cell.! !

!SkSheet methodsFor: 'accessing' stamp: 'tak 1/7/2004 16:59'!
plan
	^ plan! !

!SkSheet methodsFor: 'updating' stamp: 'tak 1/13/2004 16:29'!
rememberUpdatesOn: holder 
	dependMap keys do: [:key | (holder cellAt: key) remember]! !

!SkSheet methodsFor: 'updating' stamp: 'tak 4/8/2004 22:39'!
resolveOn: holder 
	"Aplly all constrains to cells in holder"
	| updates |
	dependMap
		ifNil: [^ self].
	updates _ Set new
				addAll: (self updatedCellsOn: holder);
				
				addAll: (self updatedCellsInCardOn: holder);
				 yourself.
	plan
		do: [:pair | (updates includes: pair key)
				ifTrue: [pair value resolveOn: holder at: pair key]].
	self rememberUpdatesOn: holder.
"
	updates isEmpty not
		ifTrue: [Transcript show: updates asString;
				 cr]
"! !

!SkSheet methodsFor: 'planning' stamp: 'tak 1/2/2004 12:24'!
sortBlock
	^ [:a :b | a y < b y
		or: [a y == b y
				and: [a x <= b x]]]! !

!SkSheet methodsFor: 'updating' stamp: 'tak 1/18/2004 20:36'!
updatedCellsInCardOn: holder 
	"Ask card to want to update?"
	^ self cardPositions
		select: [:each | (map at: each) contents wantsUpdate]! !

!SkSheet methodsFor: 'updating' stamp: 'tak 1/13/2004 16:29'!
updatedCellsOn: holder 
	"detect where I have to do"

	| updates |
	updates := Set new.
	dependMap keys do: 
			[:key | 
			(holder cellAt: key) hasUpdated 
				ifTrue: [updates addAll: (dependMap at: key)]].
	^updates! !

!SkSheet methodsFor: 'accessing' stamp: 'tak 1/18/2004 23:42'!
updateKeys
	| propertyKeys newMap |
	propertyKeys _ self findName: 'PropertyKeys'.
	newMap _ Dictionary new.
	map
		associationsDo: [:assoc | (assoc key class == Point
					or: [propertyKeys includes: assoc key])
				ifTrue: [newMap at: assoc key put: assoc value]].
	(map values
		select: [:cell | cell contents class == SkName]
		thenCollect: [:cell | cell contents])
		do: [:each | newMap at: each key put: each cell].
	map _ newMap.! !

!SkSheet methodsFor: 'planning' stamp: 'tak 1/13/2004 16:29'!
updatePlan
	"Order of plan is reserved, but not redundant"

	| keys remain |
	keys := self collectOrder.
	remain := keys asSet.
	plan := (keys select: 
					[:key | 
					(remain includes: key) and: 
							[(self cellAt: key) hasFormula and: 
									[remain remove: key.
									true]]]
				thenCollect: [:key | key -> (map at: key)]) asArray.
	dependMap := self dependMap! !

!SkSheet methodsFor: 'updating' stamp: 'tak 12/30/2003 22:20'!
wantsSteps
	^ true! !

SkMap subclass: #SkSimple
	instanceVariableNames: 'rules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkSimple commentStamp: 'tak 3/11/2004 19:12' prior: 0!
I am a simple spreadsheet object.!

!SkSimple methodsFor: 'accessing' stamp: 'tak 3/15/2004 12:43'!
addRule: aSkRule
	rules add: aSkRule.
	^ aSkRule.! !

!SkSimple methodsFor: 'accessing' stamp: 'tak 3/11/2004 19:38'!
at: key ifAbsent: aBlock 
	^ (map at: key ifAbsent: aBlock) value! !

!SkSimple methodsFor: 'accessing' stamp: 'tak 3/11/2004 19:27'!
at: key put: anObject
	map at: key put: anObject.
	^ anObject! !

!SkSimple methodsFor: 'initialization' stamp: 'tak 3/15/2004 12:50'!
initialize
	super initialize.
	map _ Dictionary new.
	rules _ OrderedCollection new.
! !

!SkSimple methodsFor: 'updating' stamp: 'tak 3/15/2004 13:26'!
resolveOn: holder
	rules
		do: [:each | each resolveOn: holder]! !

!SkSimple methodsFor: 'accessing' stamp: 'tak 3/11/2004 19:31'!
textAt: aPoint 
	^ (self at: aPoint) asString! !

!SkSimple methodsFor: 'accessing' stamp: 'tak 3/15/2004 12:29'!
textAt: aPoint put: aText 
	aText = ''
		ifTrue: [self removeAt: aPoint.
			^ ''].
	map at: aPoint put: aText asString.
	self changed.
	^ aText! !

!SkNamed methodsFor: 'structure' stamp: 'tak 12/28/2003 22:31'!
parent
	^ parent! !

!SkNamed methodsFor: 'structure' stamp: 'tak 1/8/2004 15:19'!
parent: aSkObject 
	parent _ aSkObject! !

!SkNamed methodsFor: 'copying' stamp: 'tak 1/19/2004 19:48'!
siblingWith: deepCopier 
	^ self new! !

!SkNamed methodsFor: 'copying' stamp: 'tak 1/24/2004 09:54'!
veryDeepCopyWith: deepCopier 
	| new |
	new _ super veryDeepCopyWith: deepCopier.
	new parent: SkProject current uniqueName: self ruleName.
	^ new! !

!SkNamed methodsFor: 'copying' stamp: 'tak 1/19/2004 19:12'!
veryDeepInner: deepCopier 
	"parent is not copied"
	super veryDeepInner: deepCopier.
! !

!SkObject class methodsFor: 'accessing' stamp: 'tak 1/24/2004 02:13'!
codeString
	^ self ruleName! !

!SkObject class methodsFor: 'accessing' stamp: 'tak 1/23/2004 22:25'!
color: aColor 
	SkColorSet for: self color: aColor! !

!SkObject class methodsFor: 'instance creation' stamp: 'tak 3/11/2004 19:19'!
contents: aBlock 
	| holder |
	holder _ self new.
	aBlock value: holder.
	^ holder! !

!SkObject class methodsFor: 'instance creation' stamp: 'tak 1/23/2004 22:24'!
defaultColor
	^ Color blue! !

!SkObject class methodsFor: 'instance creation' stamp: 'tak 1/23/2004 22:21'!
defaultName
	^ self name allButFirst: 2! !

!SkObject class methodsFor: 'accessing' stamp: 'tak 1/23/2004 22:27'!
direction
	^ #right! !

!SkObject class methodsFor: 'instance creation' stamp: 'tak 1/23/2004 22:31'!
direction: aSymbol
	^self new direction: aSymbol! !

!SkObject class methodsFor: 'instance creation' stamp: 'Richo 10/18/2011 12:26'!
grid
	| case grid |
	grid _ SkBasicSheetMorph new model: (case _ self new).
	grid area: case defaultArea.
	^ grid! !

!SkObject class methodsFor: 'class initialization' stamp: 'tak 3/30/2004 22:40'!
initialize
	"self initialize"
	super initialize.
	SkColorSet initialize.
	NullCell _ SkNullCell new.
	Root _ self initializeRoot.
	self initializeLibrary.
! !

!SkObject class methodsFor: 'class initialization' stamp: 'tak 1/24/2004 08:19'!
initializeLibrary
	"self initializeLibrary"
	| library |
	library _ (self root at: 'Library' put: SkDictionary new)
				parent: self root.
	library locked: true.
	library
		color: (Color
				r: 0.258
				g: 0.645
				b: 0.0).
	SkLibrary allSubclasses asArray , {SkSheet. SkDictionary}
		do: [:each | 
			each parent: library;
				 name: each defaultName.
			each color: each defaultColor].
	self initializePropertyKeys! !

!SkObject class methodsFor: 'class initialization' stamp: 'tak 1/18/2004 23:25'!
initializePropertyKeys
	| library |
	library _ self root at: 'Library'.
	library at: 'PropertyKeys' put: {'CellExtent'} asSet! !

!SkObject class methodsFor: 'class initialization' stamp: 'tak 1/24/2004 14:01'!
initializeRoot
	| root library projects |
	root _ SkDictionary new.
	library _ SkDictionary new.
	library color:  (Color r: 0.258 g: 0.645 b: 0.0).
	projects _ SkDictionary new.
	root at: 'Root' put: root.
	root parent: root.
	root at: 'Library' put: library.
	library parent: root.
	root at: 'Projects' put: projects.
	projects parent: root.
	projects locked: true.
	root locked: true.
	^ root! !

!SkObject class methodsFor: 'menu' stamp: 'tak 1/25/2004 16:50'!
invokeCardMenu: evt! !

!SkObject class methodsFor: 'testing' stamp: 'tak 1/23/2004 22:32'!
isInstance
	^ false! !

!SkObject class methodsFor: 'testing' stamp: 'tak 1/23/2004 22:26'!
isSkObject
	^true! !

!SkObject class methodsFor: 'structure' stamp: 'tak 1/23/2004 22:22'!
name: aString 
	self parent uniqueNameAt: aString put: self rule! !

!SkObject class methodsFor: 'instance creation' stamp: 'tak 3/11/2004 19:17'!
name: aString contents: aBlock 
	| holder |
	holder _ self new name: aString.
	aBlock value: holder.
	^ holder! !

!SkObject class methodsFor: 'instance creation' stamp: 'tak 12/24/2003 18:27'!
new
	^ super new initialize! !

!SkObject class methodsFor: 'instance creation' stamp: 'tak 1/24/2004 13:01'!
open
	"self open"
	^ self new grid openInHand! !

!SkObject class methodsFor: 'structure' stamp: 'tak 1/23/2004 22:23'!
parent
	^ self root at: 'Library'! !

!SkObject class methodsFor: 'structure' stamp: 'tak 1/23/2004 22:20'!
parent: anObject
	"parent can't set"! !

!SkObject class methodsFor: 'holder and card' stamp: 'tak 1/19/2004 07:48'!
releaseHolder! !

!SkObject class methodsFor: 'accessing' stamp: 'tak 12/26/2003 10:50'!
root
	^ Root! !

!SkObject class methodsFor: 'accessing' stamp: 'tak 1/23/2004 22:24'!
rule
	^ self! !

!SkObject class methodsFor: 'accessing' stamp: 'tak 1/23/2004 22:28'!
ruleName
	"Answer name or nil"
	^ self parent
		ifNotNil: [self parent keyAtValue: self rule]! !

!SkObject class methodsFor: 'copying' stamp: 'tak 1/19/2004 19:40'!
siblingWith: deepCopier 
! !

!SkObject class methodsFor: 'accessing' stamp: 'tak 1/23/2004 22:28'!
size
	^ 0! !

!SkObject class methodsFor: 'accessing' stamp: 'tak 1/27/2004 10:15'!
size: aNumber
	^ aNumber! !

!SkObject class methodsFor: 'updating' stamp: 'tak 1/23/2004 22:27'!
stopStepping
	World
		ifNotNil: [(World valueOfProperty: #SkSheet)
				ifNotNilDo: [:set | set remove: self ifAbsent: []]]! !

!SkObject methodsFor: 'structure' stamp: 'tak 1/19/2004 08:43'!
adopt: aSkObject 
	(self findName: aSkObject ruleName)
			= aSkObject rule
		ifTrue: [^ self].
	self uniqueNameAt: aSkObject ruleName put: aSkObject! !

!SkObject methodsFor: 'accessing' stamp: 'tak 12/29/2003 00:58'!
args
	^ #()! !

!SkObject methodsFor: 'cell accessing' stamp: 'tak 1/20/2004 22:44'!
assuredCellAt: key 
	^ self cellAt: key! !

!SkObject methodsFor: 'structure' stamp: 'tak 4/10/2004 23:08'!
attachProject
	self parent: SkProject current uniqueName: self ruleName
! !

!SkObject methodsFor: 'accessing' stamp: 'tak 12/28/2003 11:24'!
at: key 
	"Anwer '' NOT nil when unfound"
	^ self
		at: key
		ifAbsent: [^ '']! !

!SkObject methodsFor: 'accessing' stamp: 'tak 12/30/2003 08:39'!
at: key ifAbsent: aBlock 
	"answer a value of the point"
	^ (self
		cellAt: key
		ifAbsent: [^ aBlock value]) contents! !

!SkObject methodsFor: 'accessing' stamp: 'tak 12/30/2003 16:37'!
at: aPosition put: anObject 
	| cell |
	cell _ self assuredCellAt: aPosition.
	cell contents: anObject.
	^ anObject! !

!SkObject methodsFor: 'structure' stamp: 'tak 1/19/2004 08:44'!
beAlone
	self parent
		ifNotNil: [self parent removeAt: self ruleName]! !

!SkObject methodsFor: 'accessing' stamp: 'tak 1/23/2004 23:27'!
cardList: aRectangle 
	^ self cardPositions
		collect: [:key | key
				-> (self at: key)]! !

!SkObject methodsFor: 'accessing' stamp: 'tak 1/23/2004 23:27'!
cardPositions
	^ #()! !

!SkObject methodsFor: 'holder and card' stamp: 'tak 1/21/2004 16:07'!
caseAt: key put: case
	"Drop the case into me"
	self at: key put: case.! !

!SkObject methodsFor: 'cell accessing' stamp: 'tak 12/28/2003 22:42'!
cellAt: key 
 	^ self
		cellAt: key
		ifAbsent: [NullCell]! !

!SkObject methodsFor: 'cell accessing' stamp: 'tak 12/28/2003 22:47'!
cellAt: key ifAbsent: aBlock 
	^ aBlock value! !

!SkObject methodsFor: 'accessing' stamp: 'tak 1/19/2004 08:44'!
codeString
	^ self ruleName , ' direction: ' , self direction printString , ' size: ' , (self size
			ifNil: [0]) printString! !

!SkObject methodsFor: 'planning' stamp: 'tak 1/9/2004 17:49'!
collectDependents
	^ #()! !

!SkObject methodsFor: 'updating' stamp: 'tak 1/9/2004 16:40'!
collectDependentsForCard: aPoint 
	^nil! !

!SkObject methodsFor: 'updating' stamp: 'tak 1/13/2004 17:06'!
collectUpdatesForCard: aPoint 
	^#()! !

!SkObject methodsFor: 'updating' stamp: 'tak 1/13/2004 22:32'!
collectUpdates: aPoint 
	"Answer updated position"
	^ #()! !

!SkObject methodsFor: 'accessing' stamp: 'tak 1/11/2004 17:57'!
color
	^ SkColorSet basicFor: self rule! !

!SkObject methodsFor: 'accessing' stamp: 'tak 1/11/2004 17:36'!
color: aColor 
	SkColorSet for: self color: aColor! !

!SkObject methodsFor: 'initialization' stamp: 'tak 1/11/2004 18:26'!
defaultArea
	^ 0 @ 0 extent: 3 @ 3! !

!SkObject methodsFor: 'accessing' stamp: 'tak 1/11/2004 17:36'!
defaultColor
	^ Color blue.! !

!SkObject methodsFor: 'constants' stamp: 'tak 4/10/2004 23:10'!
defaultName
	^ 'Sheet'! !

!SkObject methodsFor: 'accessing' stamp: 'tak 1/8/2004 22:57'!
dependMap
	^ #()! !

!SkObject methodsFor: 'accessing' stamp: 'tak 12/24/2003 23:56'!
direction
	^ #right! !

!SkObject methodsFor: 'accessing' stamp: 'tak 12/29/2003 12:24'!
direction: aSymbol 
! !

!SkObject methodsFor: 'instance creation' stamp: 'tak 1/18/2004 15:59'!
direction: direction size: aNumber 
	| card |
	card := self rule new.
	card direction: direction.
	card size: aNumber.
	^card! !

!SkObject methodsFor: 'name accessing' stamp: 'tak 12/29/2003 12:41'!
findLibrary: aString ifAbsent: aBlock 
	^ (self class root findName: 'Library')
		at: aString
		ifAbsent: aBlock! !

!SkObject methodsFor: 'name accessing' stamp: 'tak 12/29/2003 12:35'!
findName: aString 
	^ self
		findName: aString
		ifAbsent: [nil]! !

!SkObject methodsFor: 'name accessing' stamp: 'tak 12/30/2003 21:26'!
findName: aString ifAbsent: aBlock 
	"Search parent if not found"
	aString = 'parent'
		ifTrue: [^ self parent].
	^ self
		at: aString
		ifAbsent: [(self = self parent
					or: [self parent isNil])
				ifTrue: [self findLibrary: aString ifAbsent: aBlock]
				ifFalse: [self parent findName: aString ifAbsent: aBlock]]! !

!SkObject methodsFor: 'initialization' stamp: 'Richo 10/18/2011 12:26'!
grid
	| grid |
	grid _ SkBasicSheetMorph new model: self.
	grid area: self defaultArea.
	^ grid! !

!SkObject methodsFor: 'structure' stamp: 'tak 12/28/2003 12:06'!
includesKey: key 
	self
		at: key
		ifAbsent: [^ false].
	^ true! !

!SkObject methodsFor: 'initialization' stamp: 'tak 12/24/2003 20:18'!
initialize
	"initialize code is here"! !

!SkObject methodsFor: 'accessing' stamp: 'tak 1/21/2004 10:30'!
inspectAt: key 
	| inspector |
	inspector _ SkCellInspector holder: self key: key.
	inspector
		openLabel: (SkParser pointToA1Name: key)! !

!SkObject methodsFor: 'holder and card' stamp: 'tak 1/23/2004 14:55'!
installFormulaAt: aPoint 
! !

!SkObject methodsFor: 'initialization' stamp: 'tak 1/18/2004 18:46'!
install: aSkCard to: aSkObject
	"It can remove when SkDefine doesn't use SkProxy"! !

!SkObject methodsFor: 'menu' stamp: 'tak 1/25/2004 16:49'!
invokeCardMenu: evt! !

!SkObject methodsFor: 'testing' stamp: 'tak 1/23/2004 21:47'!
isInstance
	^ true! !

!SkObject methodsFor: 'testing' stamp: 'tak 1/18/2004 15:26'!
isSkObject
	^ true! !

!SkObject methodsFor: 'updating' stamp: 'tak 1/24/2004 10:59'!
isStepping
	^ SkProject current stepList includes: self! !

!SkObject methodsFor: 'structure' stamp: 'tak 12/28/2003 12:04'!
keyAtValue: anObject 
	^ self
		keyAtValue: anObject
		ifAbsent: []! !

!SkObject methodsFor: 'structure' stamp: 'tak 12/28/2003 12:12'!
keyAtValue: anObject ifAbsent: aBlock 
	^ self subclassResponsibility! !

!SkObject methodsFor: 'structure' stamp: 'tak 1/24/2004 09:54'!
name: aString 
	self parent
		ifNil: [self parent: SkProject current].
	self parent uniqueNameAt: aString put: self rule! !

!SkObject methodsFor: 'instance creation' stamp: 'tak 1/22/2004 23:19'!
new
	"Build instance object"
	^ self isInstance
		ifTrue: [self]
		ifFalse: [SkProxy newFrom: self]! !

!SkObject methodsFor: 'structure' stamp: 'tak 12/24/2003 20:19'!
parent
	^ nil! !

!SkObject methodsFor: 'structure' stamp: 'tak 12/24/2003 19:01'!
parent: aSkRule
	self subclassResponsibility! !

!SkObject methodsFor: 'structure' stamp: 'tak 1/8/2004 20:58'!
parent: aSkObject uniqueName: aString 
	self parent: aSkObject;
		 name: aString! !

!SkObject methodsFor: 'support' stamp: 'tak 1/18/2004 19:10'!
pointForHolder: holderPoint at: aPoint 
	"Translating cordinate local to holder 
	holderPoint is a point that I am put"
	| rotateDirection standardized |
	rotateDirection _ self direction == #right
				ifFalse: [self direction == #down
						ifTrue: [#right]
						ifFalse: [self direction == #left
								ifTrue: [#pi]
								ifFalse: [self direction == #up
										ifTrue: [#left]]]].
	standardized _ aPoint + (0 @ -1).
	rotateDirection
		ifNotNil: [standardized _ standardized rotateBy: rotateDirection centerAt: 0 @ 0].
	^ standardized + holderPoint! !

!SkObject methodsFor: 'accessing' stamp: 'tak 1/19/2004 08:44'!
printOn: aStream 
	| aName |
	super printOn: aStream.
	(aName _ self ruleName printString) notNil
		ifTrue: [aStream nextPutAll: '<' , aName , '>'].
	aStream nextPutAll: '('.
	aStream
		print: self identityHash;
		nextPutAll: ')'! !

!SkObject methodsFor: 'updating' stamp: 'tak 1/18/2004 17:44'!
referenceAt: aPoint 
	"Answer the dependents object's point(with cordinate of holder)."
	^ #()! !

!SkObject methodsFor: 'holder and card' stamp: 'tak 1/19/2004 00:50'!
releaseHolder! !

!SkObject methodsFor: 'cell accessing' stamp: 'tak 12/30/2003 20:32'!
removeAt: aPosition
	"Remove value and formula, Then answer the cell"
	^NullCell! !

!SkObject methodsFor: 'updating' stamp: 'tak 1/18/2004 19:40'!
resolve
	"Rule should not be specified if instantiation is done"
	self rule resolveOn: self! !

!SkObject methodsFor: 'updating' stamp: 'tak 12/29/2003 00:35'!
resolveOn: holder 
! !

!SkObject methodsFor: 'accessing' stamp: 'tak 12/28/2003 22:17'!
rule
	^ self! !

!SkObject methodsFor: 'structure' stamp: 'tak 1/24/2004 08:40'!
ruleName
	"Answer name or nil"
	^ self parent
		ifNil: [self rule class ruleName]
		ifNotNil: [self parent keyAtValue: self rule]! !

!SkObject methodsFor: 'updating' stamp: 'tak 1/24/2004 14:09'!
safetyResolve
	[self resolve]
		ifError: [:err :rcvr | 
			self stopStepping.
			self error: err]! !

!SkObject methodsFor: 'updating' stamp: 'tak 1/24/2004 14:10'!
saftyResolve
	self safetyResolve! !

!SkObject methodsFor: 'copying' stamp: 'tak 1/19/2004 19:38'!
siblingWith: deepCopier 
	^ self veryDeepCopyWith: deepCopier! !

!SkObject methodsFor: 'accessing' stamp: 'tak 12/29/2003 12:06'!
size
	^ 0! !

!SkObject methodsFor: 'accessing' stamp: 'tak 12/29/2003 12:06'!
size: aNumber
! !

!SkObject methodsFor: 'updating' stamp: 'tak 1/24/2004 14:26'!
startStepping
	| stepList |
	self wantsSteps
		ifFalse: [^ self].
	self attachProject.
	stepList _ SkProject current stepList.
	(stepList includes: self)
		ifFalse: [stepList add: self]! !

!SkObject methodsFor: 'updating' stamp: 'tak 1/24/2004 10:52'!
stopStepping
	SkProject current stepList remove: self! !

!SkObject methodsFor: 'accessing' stamp: 'tak 3/31/2004 13:20'!
textAt: aPoint 
	"I am send when a user want to edit the value by text editor"
	| cell contents |
	aPoint = (0 @ 0)
		ifTrue: [^ self ruleName asString].
	cell _ self cellAt: aPoint.
	^ cell formula
		ifNil: [contents _ (self cellAt: aPoint) contents.
			contents isText
				ifTrue: [contents]
				ifFalse: [contents asCellText asText]]
		ifNotNil: [cell formula]! !

!SkObject methodsFor: 'accessing' stamp: 'tak 1/23/2004 19:29'!
textAt: aPoint put: aText 
	| cell |
	aText = ''
		ifTrue: [cell _ self removeAt: aPoint.
			cell hasCard
				ifTrue: [cell contents releaseHolder.
					self updatePlan.
					self changed: #cardList].
			^ ''].
	aPoint = (0 @ 0)
		ifTrue: [^ self name: aText asString].
	cell _ self assuredCellAt: aPoint.
	cell editContents: aText.
	cell resolveFormulaOn: self at: aPoint.
	self installFormulaAt: aPoint.
	self changed.
	^ aText! !

!SkObject methodsFor: 'structure' stamp: 'tak 4/10/2004 23:10'!
uniqueNameAt: aString put: aSkObject 
	"put object with unique name"
	| rule oldKey newName |
	rule _ self rule.
	oldKey _ rule
				keyAtValue: aSkObject
				ifAbsent: [].
	"object has the name already"
	(aString notNil
			and: [aString = oldKey])
		ifTrue: [^ aSkObject].
	"rename"
	oldKey
		ifNotNil: [rule removeAt: oldKey].
	newName _ self
				uniqueNameLike: (aString
						ifNil: [self defaultName])
				satisfy: [:s | (rule includesKey: s) not].
	rule at: newName put: aSkObject.
	"aSkObject parent: rule."
	^ aSkObject! !

!SkObject methodsFor: 'support' stamp: 'tak 12/31/2003 12:00'!
uniqueNameLike: aString satisfy: aBlock
"
self new uniqueNameLike: 'test' satisfy: [:s | (#('test' 'test1' 'test2') includes: s) not] 
self new uniqueNameLike: 'test1' satisfy: [:s | (#('test' 'test1' 'test2') includes: s) not] 
"
	| try |
	(aBlock value: aString)
		ifTrue: [^ aString]
		ifFalse: [1
				to: 999999
				do: [:i | 
					try _ aString splitInteger first , i printString.
					(aBlock value: try)
						ifTrue: [^ try]]]! !

!SkObject methodsFor: 'accessing' stamp: 'tak 1/24/2004 09:54'!
up
	^ self parent
		ifNil: [SkProject current]! !

!SkObject methodsFor: 'accessing' stamp: 'tak 1/19/2004 08:36'!
updateKeys
! !

!SkObject methodsFor: 'updating' stamp: 'tak 1/23/2004 22:29'!
updatePlan! !

!SkObject methodsFor: 'updating' stamp: 'tak 1/13/2004 23:01'!
wantsUpdate
	^ false! !

!SkObject methodsFor: 'arithmetic' stamp: 'tak 1/4/2004 23:37'!
++ anObject
	^ SkParametric new func: #+ arg1: self arg2: anObject
	! !

SkObject subclass: #SkParametric
	instanceVariableNames: 'func arg1 arg2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base-Sheet'!

!SkParametric methodsFor: 'accessing' stamp: 'tak 1/20/2004 22:43'!
cellAt: aPoint ifAbsent: aBlock 
	| holder |
	holder _ ValueHolder new.
	holder
		contents: ((arg1 isSkObject
				ifTrue: [arg1 at: aPoint]
				ifFalse: [arg1])
				perform: func
				with: (arg2 isSkObject
						ifTrue: [arg2 at: aPoint]
						ifFalse: [arg2])).
	^ holder! !

!SkParametric methodsFor: 'initialization' stamp: 'tak 1/20/2004 22:40'!
func: aSymbol arg1: obj1 arg2: obj2
	func _ aSymbol.
	arg1 _ obj1.
	arg2 _ obj2.
! !

SkObject subclass: #SkProxy
	instanceVariableNames: 'rule map size direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkProxy class methodsFor: 'instance creation' stamp: 'tak 1/23/2004 00:40'!
newForTest
	"It is just used for test"
	^ self newFrom: SkSheet new! !

!SkProxy class methodsFor: 'instance creation' stamp: 'tak 1/22/2004 23:25'!
newFrom: aSkObject 
	^ super new rule: aSkObject rule! !

!SkProxy methodsFor: 'accessing' stamp: 'tak 1/22/2004 23:51'!
argPositions
	^ (1 to: size)
		collect: [:index | index @ 1]! !

!SkProxy methodsFor: 'cell accessing' stamp: 'tak 1/23/2004 00:53'!
assuredCellAt: key 
	key class == Point
		ifFalse: [^ rule assuredCellAt: key].
	^ map
		at: key
		ifAbsent: [map
				at: key
				put: (SkProxyCell new
						holderCell: SkValueCell new
						argCell: (rule assuredCellAt: key))]! !

!SkProxy methodsFor: 'updating' stamp: 'tak 1/23/2004 19:23'!
cardChanged
	self changed: #cardList.! !

!SkProxy methodsFor: 'accessing' stamp: 'tak 1/23/2004 18:47'!
cardList: aRectangle 
	^ self cardPositions
		select: [:key | (self at: key) isSkObject]
		thenCollect: [:key | key
				-> (self at: key)]! !

!SkProxy methodsFor: 'accessing' stamp: 'tak 1/23/2004 19:05'!
cardPositions
	^ (map keys
		select: [:each | each class = Point
				and: [(map at: each) hasCard]]) addAll: rule cardPositions;
		 yourself! !

!SkProxy methodsFor: 'cell accessing' stamp: 'tak 1/22/2004 23:31'!
cellAt: key ifAbsent: aBlock 
	^ map
		at: key
		ifAbsent: [rule cellAt: key ifAbsent: aBlock]! !

!SkProxy methodsFor: 'updating' stamp: 'tak 1/23/2004 00:36'!
collectDependentsForCard: aPoint 
	| points dict |
	self flag: #TODO.
	"It has a BAD assumption"
	points _ self referenceAt: aPoint.
	dict _ Dictionary new.
	^ points size > 1
		ifTrue: [dict at: points first put: {aPoint} asSet; yourself]! !

!SkProxy methodsFor: 'accessing' stamp: 'tak 1/22/2004 23:45'!
direction
	^ direction! !

!SkProxy methodsFor: 'accessing' stamp: 'tak 1/22/2004 23:45'!
direction: aSymbol 
	direction _ aSymbol! !

!SkProxy methodsFor: 'updating' stamp: 'tak 1/24/2004 23:33'!
holder: aSkSheet at: aPoint 
	| holderCell |
	(aSkSheet cellAt: aPoint) hasCard
		ifFalse: [^ aSkSheet].
	(self referenceAt: aPoint)
		withIndexDo: [:pos :index | 
			holderCell _ aSkSheet assuredCellAt: pos.
			map
				at: index @ 1
				put: (SkProxyCell new
						holderCell: holderCell
						argCell: (rule assuredCellAt: index @ 1))]! !

!SkProxy methodsFor: 'initialization' stamp: 'tak 1/22/2004 23:30'!
initialize
	super initialize.
	direction _ #right.
	map _ Dictionary new.
	size _ 0! !

!SkProxy methodsFor: 'holder and card' stamp: 'tak 1/23/2004 19:57'!
installFormulaAt: aPoint 
	rule installFormulaAt: aPoint.
	"Cell is not needed where card is"
	(rule cellAt: aPoint) hasCard ifTrue: [
	self removeAt: aPoint].! !

!SkProxy methodsFor: 'structure' stamp: 'tak 1/22/2004 23:27'!
parent
	^ rule ifNotNil: [rule parent]! !

!SkProxy methodsFor: 'structure' stamp: 'tak 1/22/2004 23:40'!
parent: aSkRule
	rule parent: aSkRule! !

!SkProxy methodsFor: 'updating' stamp: 'tak 1/22/2004 23:52'!
referenceAt: aPoint 
	"Answer the dependents object's point"
	^ self argPositions
		collect: [:each | self pointForHolder: aPoint at: each]! !

!SkProxy methodsFor: 'cell accessing' stamp: 'tak 1/22/2004 23:36'!
removeAt: key 
	| cell |
	cell _ self cellAt: key.
	map
		removeKey: key
		ifAbsent: [].
	^ cell! !

!SkProxy methodsFor: 'updating' stamp: 'tak 1/23/2004 16:25'!
resolveOn: holder
	rule resolveOn: self! !

!SkProxy methodsFor: 'accessing' stamp: 'tak 1/22/2004 23:21'!
rule
	^ rule! !

!SkProxy methodsFor: 'accessing' stamp: 'tak 1/22/2004 23:22'!
rule: SkObject
	rule
		ifNotNil: [rule removeDependent: self].
	SkObject
		ifNotNil: [SkObject addDependent: self].
	rule _ SkObject
! !

!SkProxy methodsFor: 'copying' stamp: 'tak 1/28/2004 22:39'!
siblingWithInner: deepCopier 
	map _ map veryDeepCopyWith: deepCopier.
	size _ size veryDeepCopyWith: deepCopier.
	direction _ direction veryDeepCopyWith: deepCopier.
	^ self! !

!SkProxy methodsFor: 'copying' stamp: 'tak 1/28/2004 22:40'!
siblingWith: deepCopier 
	| new |
	new _ self clone.
	new siblingWithInner: deepCopier.
	^ new! !

!SkProxy methodsFor: 'accessing' stamp: 'tak 1/22/2004 23:48'!
size
	^ size! !

!SkProxy methodsFor: 'accessing' stamp: 'tak 1/22/2004 23:48'!
size: aNumber 
	size _ aNumber! !

!SkProxy methodsFor: 'accessing' stamp: 'tak 1/23/2004 01:46'!
up
	^ rule! !

!SkProxy methodsFor: 'updating' stamp: 'tak 1/23/2004 19:10'!
updateCardList
	"Delete dispensable cards"
	| ruleCards |
	ruleCards _ rule cardPositions.
	(self cardPositions
		select: [:key | (ruleCards includes: key) not])
		do: [:key | self removeAt: key]! !

!SkProxy methodsFor: 'accessing' stamp: 'tak 1/23/2004 00:38'!
updateKeys
	rule updateKeys! !

!SkProxy methodsFor: 'updating' stamp: 'tak 1/23/2004 19:11'!
update: anObject 
	anObject == #cardList
		ifTrue: [self updateCardList].
	self changed: anObject! !

!SkProxy methodsFor: 'updating' stamp: 'tak 1/22/2004 23:40'!
wantsSteps
	^ true! !

SkObject subclass: #SkRefFinder
	instanceVariableNames: 'keys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkRefFinder methodsFor: 'accessing' stamp: 'tak 12/31/2003 16:53'!
at: key 
	keys add: key.
	^ ''! !

!SkRefFinder methodsFor: 'accessing' stamp: 'tak 12/31/2003 16:50'!
at: aPosition put: anObject 
	^ anObject! !

!SkRefFinder methodsFor: 'initialization' stamp: 'tak 1/7/2004 18:11'!
initialize
	super initialize.
	keys _ Set new.! !

!SkRefFinder methodsFor: 'accessing' stamp: 'tak 12/31/2003 16:56'!
keys
	^ keys! !

Object subclass: #SkRule
	instanceVariableNames: 'observer subjects rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkRule class methodsFor: 'instance creation' stamp: 'tak 3/15/2004 12:47'!
observer: obs subjects: sub rule: aBlock 
	^ self new
		observer: obs
		subjects: sub
		rule: aBlock! !

!SkRule methodsFor: 'initialization' stamp: 'tak 3/15/2004 12:47'!
observer: obs subjects: sub rule: aBlock 
	observer _ obs.
	subjects _ sub.
	rule _ aBlock! !

!SkRule methodsFor: 'printing' stamp: 'tak 3/15/2004 13:10'!
printOn: aStream 
	observer printOn: aStream.
	aStream nextPutAll: ' rule: {'.
	subjects
		do: [:each | 
			each printOn: aStream.
			aStream nextPut: $.].
	aStream nextPutAll: '} do: '.
	rule printOn: aStream.! !

!SkRule methodsFor: 'evaluating' stamp: 'tak 3/15/2004 13:28'!
resolveOn: holder 
	holder
		at: observer
		put: (rule
				valueWithArguments: (subjects
						collect: [:each | holder at: each]))! !

PackageInfo subclass: #SkeletonBaseInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkeletonBaseInfo commentStamp: 'tak 4/10/2004 22:24' prior: 0!
This is a spreadsheet package in Skeleton.
To open a spreadsheet, try
SkSheet open.


























-- workspace --

*  package building

SkeletonBaseInfo fileOutSar.
SkeletonConnectorsInfo fileOutSar.

* make change set to current project *
self makeChangeSetForThisPackage

* benchmark
MessageTally spyOn: [1000 timesRepeat: [World runStepMethods]]

* It's useful for debug set/unset when old project is hung.
SkGridMorph>>isDebug

* sound initialize *
self createSoundLibFromWav: 'sound\cas.wav' name: 'cassete'
self createSoundLibFromWav: 'sound\cork.wav' name: 'cork'
self createSoundLibFromWav: 'sound\arrow.wav' name: 'arrow'
self createSoundLibFromWav: 'sound\mochi.wav' name: 'mochi'
self createSoundLibFromWav: 'sound\unstick.wav' name: 'unstick'
self createSoundLibFromWav: 'sound\rice.wav' name: 'rice'

* Initialize
Compiler evaluate: self new postscriptText

* stepping list
(World valueOfProperty: #SkSheet) ifNotNilDo: [:set | set asArray]

* for DEMO
TTCFont newTextStyleFromTTFile: 'C:\WINDOWS\Fonts\verdana.ttf'.
TTCFont newTextStyleFromTTFile: 'C:\WINDOWS\Fonts\pala.ttf'

* debug for Babel
Language subclass: #Romaji  	instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'Babel-Kernel'.
Romaji compile: 'name
^ #Romaji'!

!SkeletonBaseInfo class methodsFor: 'fileIn/Out' stamp: 'tak 1/19/2004 23:24'!
addClass: aClass toChangeset: aChangeSet 
	aChangeSet addClass: aClass.
	aChangeSet commentClass: aClass.
	aClass selectors
		do: [:aSymbol | aChangeSet adoptSelector: aSymbol forClass: aClass].
	aClass class selectors
		do: [:aSymbol | aChangeSet adoptSelector: aSymbol forClass: aClass class].
	^ aChangeSet! !

!SkeletonBaseInfo class methodsFor: 'class initialization' stamp: 'kfr 10/17/2011 23:58'!
initialize
	self installMenu.
	self installWorld.
	"self installSound."
	"self addPseudoMethodForBabel"
! !

!SkeletonBaseInfo class methodsFor: 'class initialization' stamp: 'tak 4/8/2004 22:37'!
installMenu
	TheWorldMenu registerOpenCommand: {'Skeleton Spreadsheet'. {SkSheet. #open}}.
! !

!SkeletonBaseInfo class methodsFor: 'class initialization' stamp: 'tak 3/30/2004 22:11'!
installSound
	| sounds |
	sounds _ self class organization listAtCategoryNamed: #'sound library'.
	sounds
		do: [:each | self perform: each]! !

!SkeletonBaseInfo class methodsFor: 'class initialization' stamp: 'tak 3/30/2004 22:12'!
installWorld
	Preferences enable: #batchPenTrails! !

!SkeletonBaseInfo class methodsFor: 'fileIn/Out' stamp: 'tak 1/19/2004 23:26'!
makeChangeSetForThisPackage
	"This is for building .pr file"
	"self makeChangeSetForThisPackage"
	| aChangeSet package |
	aChangeSet _ ChangeSet current.
	package _ self default.
	package classes
		do: [:aClass | self addClass: aClass toChangeset: aChangeSet].
	package extensionMethods
		do: [:method | aChangeSet adoptSelector: method methodSymbol forClass: method actualClass].
	aChangeSet postscriptString: self default postscriptText.
	^ aChangeSet! !

!SkeletonBaseInfo class methodsFor: 'parts bin' stamp: 'tak 4/2/2004 19:51'!
point
	"self point openInHand"
	^ EllipseMorph new extent: 24 @ 24;
	color: (Color r: 0.0 g: 0.8 b: 0.7);
	borderColor: (TranslucentColor r: 0.0 g: 0.8 b: 0.7 alpha: 0.4)
		 yourself! !

!SkeletonBaseInfo class methodsFor: 'utility' stamp: 'tak 3/30/2004 21:57'!
renameAllProtocol: before to: after 
	" 
	Change all method category.
	self renameAllProtocol: #'*skeleton-2003' to: #'obsolete-sk2003'.
	self renameAllProtocol: #'*skeleton-2003-var' to: #'obsolete-sk2003-var' 
	self renameAllProtocol: #'*skeleton-velocity' to: #'obsolete-velocity' 
	self renameAllProtocol: #'*skeleton-morph-sumim' to: #'*skeleton-connectors-sumim' 
	"
	ProtoObject
		withAllSubclassesDo: [:class | 
			(class organization listAtCategoryNamed: before) isEmpty not
				ifTrue: [class organization renameCategory: before toBe: after].
			(class class organization listAtCategoryNamed: before) isEmpty not
				ifTrue: [class organization renameCategory: before toBe: after]]! !

!SkeletonBaseInfo class methodsFor: 'constant' stamp: 'tak 4/8/2004 22:40'!
version
	^ '0.4.1'! !

!SkeletonBaseInfo methodsFor: 'naming' stamp: 'tak 3/30/2004 21:41'!
packageName
	^ 'Skeleton-Base'! !

!SkeletonBaseInfo methodsFor: 'introspection' stamp: 'tak 4/11/2004 01:19'!
readmeText
	^ 'Skeleton ', self class version, '

Skeleton is a easy scripting system with spreadsheet-like user interface.  It handles an etoy''s slot as a spread sheet''s cell. So user can describe declarative rules among morphs as spread sheet''s "=A1 +A2" style. It is similar with Visio''s "shape sheet", but Skeleton-sheet has more dynamic and real-time behavior.

Takashi Yamamiya <propella@yuri.sakura.ne.jp>
http://languagegame.org:8080/ggame/11

SkSheet example

2004-04-10
	Fix some dirty code (Remove references of Transcript, Fix a word in world menu).
	Support Babel.
'! !

PackageInfo subclass: #SkeletonInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Skeleton-Base'!

!SkeletonInfo commentStamp: 'tak 3/30/2004 21:40' prior: 0!
I am a full Skeleton package information.!

!SkeletonInfo methodsFor: 'naming' stamp: 'tak 3/30/2004 21:41'!
packageName
	^ 'Skeleton'! !

!Point methodsFor: '*skeleton-base-sheet' stamp: 'tak 1/19/2004 20:31'!
direction2: freePoint distance: distance 
	"Ask Point by extention of self - freePoint with distance.  
	(100@100 direction: 400@100 distance: 100) =  
	(200@100)"
	"IT SHOULD BE REMOVED!!!!!! use #direction:distance:"
	self flag: #TODO.
	^ self = freePoint
		ifTrue: [self]
		ifFalse: [self + (freePoint - self * distance / (freePoint - self) r)]! !
SkBasicSheetMorph initialize!
SkColorSet initialize!
SkObject initialize!
SkeletonBaseInfo initialize!
